package com.cnd3b.restcontroller.customer.notice;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.util.P2Exception;

import java.util.ArrayList;

public class notice extends Controller {
    public notice(JSONObject content) {
        super(content);
    }

    /**
     * ͨбѯ
     *
     * @return
     */
    public String query_noticeList() throws D3bException {
        /**
         *
         */
        String[] sortfield = {"t1.fisontop desc,t1.checkdate desc"};
        String sort = getSort(sortfield, "t1.fisontop desc,t1.checkdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fsummary like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                if ("Ŷ".equals(whereObject.getString("ftype"))) {
                    where.append(" and t1.tagentsid='").append(tagentsid).append("' and  t1.ftype='").append(whereObject.getString("ftype")).append("'");
                } else {
                    where.append(" and t1.ftype='").append(whereObject.getString("ftype")).append("'");
                }
            }
            String ftype = getAgent(tagentsid).getString("ftype");
            where.append(" and (");
            {
                /**
                 * ̻ŶӿԲ鿴Լ̻ͨ
                 */
                where.append("(t1.tagentsid='" + tagentsid + "')");
            }
            {
                /**
                 * ҷĳǷͨ
                 */
                where.append("or (isnull(t1.tagentsid,0)=0");
                if ("".equals(ftype)) {
                    where.append(" and fissingleagent=1");
                    if (!fisadministrator) {
                        where.append("and fisagentsubuser=1");
                    }
                } else {
                    where.append(" and fischeckagent=1 and (fisspecifiedrange=0 or exists(select * from tnotice_users where siteid=t1.siteid and tnoticeid=t1.tnoticeid and tagentsid='" + tagentsid + "'))");
                    if (!fisadministrator) {
                        where.append("and fisagentsubuser=1");
                    }
                }
                where.append(")");
            }
            {
                /**
                 * ̲鿴̻ͨ
                 */
                where.append(" or (");
                where.append("isnull(t1.tagentsid,0)>0 and (" +//˳̻ͨ
                        "exists(select * from tagents_cooperation where siteid=t1.siteid and tagentsid=t1.tagentsid and tcooperationagentsid='").append(tagentsid).append("') " +//жϵǰ̻ǷǷ̻ĺ
                        "and(fisspecifiedrange=0 or exists(select * from tnotice_users where siteid=t1.siteid and tnoticeid=t1.tnoticeid and tagentsid='").append(tagentsid).append("') )" +//ָ̻ģжϵǰ̻ǷָΧ
                        ")");
                where.append(")");
            }

            where.append(")");
        }
        SQLFactory noticehead = new SQLFactory(this, "ͨбѯ", pageSize, pageNumber, sort);
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());
        ArrayList<String> tnoticeidlist = rows.toArrayList("tnoticeid");

        SQLFactory noticeisread = new SQLFactory(this, "ͨбǷѶѯ");
        noticeisread.addParameter("siteid", siteid);
        noticeisread.addParameter("tenterprise_userid", userid);
        noticeisread.addParameter_in("tnoticeid", tnoticeidlist);
        ArrayList<String> tnoticeids = noticeisread.runSqlQuery().toArrayList("tnoticeid");

        //ͨ渽ѯ
        RowsMap attinfocountmap = getAttachmentQty("tnotice", tnoticeidlist);
        //ͨͼѯ
        RowsMap noticecovermap = getAttachmentUrl("tnotice", tnoticeidlist, "cover");

        for (Row row : rows) {
            String tnoticeid = row.getString("tnoticeid");
            row.put("fisread", tnoticeids.contains(tnoticeid) ? 1 : 0);
            row.put("fattachmentcount", attinfocountmap.containsKey(tnoticeid) ? attinfocountmap.get(tnoticeid).getRow(0).getInteger("fattachmentcount") : 0);
            row.put("attinfos", noticecovermap.get(tnoticeid));
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ͨѯ(ͨĶ)
     *
     * @return
     */
    public String query_noticeMain() throws P2Exception {
        long tnoticeid = content.getLongValue("tnoticeid");
        SQLFactory noticehead = new SQLFactory(this, "ͨѯ");
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());
        for (Row row : rows) {
            row.put("attinfos", getAttachmentUrl("tnotice", String.valueOf(tnoticeid)));
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        SQLFactory factory = new SQLFactory(this, "ͨĶʼ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("createby", username);
        factory.addParameter("tenterprise_userid", userid);
        factory.addParameter("tnoticeid", tnoticeid);
        factory.addParameter("tagentsid", tagentsid);
        dbConnect.runSqlUpdate(factory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ͨĶ
     *
     * @return
     */
    public String noticeexit() {
        long tnoticeid = content.getLongValue("tnoticeid");
        SQLFactory factory = new SQLFactory(this, "ͨĶ");
        factory.addParameter("siteid", siteid);
        factory.addParameter("tenterprise_userid", userid);
        factory.addParameter("tnoticeid", tnoticeid);
        factory.addParameter("tagentsid", tagentsid);
        dbConnect.runSqlUpdate(factory.getSQL());
        return getSucReturnObject().toString();
    }
}
