select t1.tagentsid,t2.fagentname,t2.fbrand,t1.tenterprise_userid,t3.fname,t3.fphonenumber,MIN(t1.createdate) as ffirstreadtime,MAX(t1.createdate)as flastreadtime,
count(t1.tnotice_userdataid)freadcount, sum(DATEDIFF(MINUTE,t1.createdate,t1.closedate)) freadtimes
from tnotice_userdata t1
left join tagents t2 on t1.siteid=t2.siteid and t1.tagentsid=t2.tagentsid
left join tenterprise_users t3 on t1.siteid=t3.siteid and t1.tenterprise_userid=t3.tenterprise_userid
where t1.siteid = $siteid$ and t1.tnoticeid = $tnoticeid$
group by t1.tagentsid,t2.fagentname,t2.fbrand,t1.tenterprise_userid,t3.fname,t3.fphonenumber