package com.cnd3b.restcontroller.customer.noticemag;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.*;

public class noticemag extends Controller {
    public noticemag(JSONObject content) {
        super(content);
    }


    /**
     * ͨбѯ
     *
     * @return
     */
    public String query_noticeList() {
        /**
         *
         */
        String[] sortfield = {"t1.fisontop desc,t1.checkdate desc"};
        String sort = getSort(sortfield, "t1.fisontop desc,t1.checkdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fsummary like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and t1.ftype='").append(whereObject.getString("ftype")).append("'");
            }
        }
        SQLFactory noticehead = new SQLFactory(this, "ͨбѯ", pageSize, pageNumber, sort);
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tagentsid", tagentsid);
        noticehead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());

        ArrayList<String> tnoticeidlist = rows.toArrayList("tnoticeid");
        //ͨ渽ѯ
        RowsMap attinfocountmap = getAttachmentQty("tnotice", tnoticeidlist);
        //ͨͼѯ
        RowsMap noticecovermap = getAttachmentUrl("tnotice", tnoticeidlist, "cover");

        for (Row row : rows) {
            String tnoticeid = row.getString("tnoticeid");
            row.put("fattachmentcount", attinfocountmap.containsKey(tnoticeid) ? attinfocountmap.get(tnoticeid).getRow(0).getInteger("fattachmentcount") : 0);
            row.put("attinfos", noticecovermap.get(tnoticeid));
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ͨѯ
     *
     * @return
     */
    public String query_noticeMain() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory noticehead = new SQLFactory(this, "ͨѯ");
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());

        Rows attinfosRows = getAttachmentUrl("tnotice", tnoticeid);
        rows.get(0).put("attinfos", attinfosRows);
        rows.get(0).put("headportraiturl", getHeadPic(rows.get(0).getLong("tenterprise_userid")));

        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ͨö
     *
     * @return
     */
    public String noticeontop() {
        String tnoticeid = content.getString("tnoticeid");
        int fisontop = content.getInteger("fisontop");//Ƿö
        String status = dbConnect.runSqlUpdate("update tnotice set fisontop=" + fisontop + ", changeby='" + username + "',changedate=getdate() where siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "'");
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ͨ޸
     *
     * @return
     */
    public String insertOrModify() throws D3bException, P2Exception {
        long tnoticeid = content.getLongValue("tnoticeid"); //ʱĬϴ0
        String ftype = content.getString("ftype");//ͨ
        String ftitle = content.getString("ftitle", "tnotice.ftitle", "");//
        String fsummary = content.getString("fsummary", "tnotice.fsummary", "ͨ浼");//
        String fcontent = content.getString("fcontent", "tnotice.fcontent", "");//ͨ
        boolean fisspecifiedrange = content.getBooleanValue("fisspecifiedrange");//ָ֤̻Χ
        boolean fisontop = content.getBooleanValue("fisontop");//Ƿö
        Date fbegdate = content.getDate("fbegdate");//ʼʱ
        Date fenddate = content.getDate("fenddate");//ʱ

        PaoSetRemote tnoticeSet = getP2ServerSystemPaoSet("tnotice", "siteid='" + siteid + "' and tnoticeid='" + tnoticeid + "'");
        PaoRemote tnotice = null;
        if (tnoticeid <= 0 || tnoticeSet.isEmpty()) {
            tnotice = tnoticeSet.addAtEnd();
            tnotice.setValue("siteid", siteid, 11L);//ҵID
            tnotice.setValue("createby", username, 11L);//¼
            tnotice.setValue("createdate", sysdate, 11L);//¼ʱ
            tnotice.setValue("tagentsid", tagentsid, 11L);//̻ID
            tnotice.setValue("tenterprise_userid", userid, 11L);//id
        } else {
            tnotice = tnoticeSet.getPao(0);
        }
        tnotice.setValue("ftype", ftype, 11L);//ͨ
        tnotice.setValue("ftitle", ftitle, 11L);//
        tnotice.setValue("fsummary", fsummary, 11L);//
        tnotice.setValue("fcontent", fcontent, 11L);//ͨ
        tnotice.setValue("fishomepage", false, 11L);//Żɼ
        tnotice.setValue("fischeckagent", true, 11L);//֤̻ɼ
        tnotice.setValue("fisagentsubuser", true, 11L);//̻˺ſɼ
        tnotice.setValue("fisspecifiedrange", fisspecifiedrange, 11L);//ָ֤̻Χ
        tnotice.setValue("fissingleagent", true, 11L);//̻ɼ
        tnotice.setValue("fisontop", fisontop, 11L);//Ƿö
        tnotice.setValue("fbegdate", fbegdate, 11L);//ʼʱ
        tnotice.setValue("fenddate", fenddate, 11L);//ʱ
        tnotice.setValue("changeby", username, 11L);//޸
        tnotice.setValue("changedate", sysdate, 11L);//޸ʱ

        content.put("tnoticeid", tnotice.getUniqueIDValue());
        tnoticeSet.save();
        return query_noticeMain();
    }

    /**
     * ͨԱ
     *
     * @return
     */
    public String adduser() {
        String tnoticeid = content.getString("tnoticeid");
        JSONArray idarray = content.getJSONArray("tagentsid");
        Iterator<Object> it = idarray.iterator();
        ArrayList<String> list = new ArrayList<>();
        while (it.hasNext()) {
            SQLFactory sqlFactory = new SQLFactory(this, "ͨԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tagentsid",String.valueOf(it.next()));
            list.add(sqlFactory.getSQL());
        }
        if (!list.isEmpty()) {
            String status = dbConnect.runSqlUpdate(list);
            if ("true".equals(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
        return getErrReturnObject().setErrMsg("ûѡԱ").toString();
    }


    /**
     * ɾͨԱ
     *
     * @return
     */
    public String deleteuser() {
        String tnoticeid = content.getString("tnoticeid");
        JSONArray idarray = content.getJSONArray("tagentsid");
        Iterator<Object> it = idarray.iterator();
        ArrayList<String> list = new ArrayList<>();
        while (it.hasNext()) {
            SQLFactory sqlFactory = new SQLFactory(this, "ɾͨԱ");
            sqlFactory.addParameter("siteid", siteid);
            sqlFactory.addParameter("createby", username);
            sqlFactory.addParameter("tnoticeid", tnoticeid);
            sqlFactory.addParameter("tagentsid", String.valueOf(it.next()));
            list.add(sqlFactory.getSQL());
        }
        if (!list.isEmpty()) {
            String status = dbConnect.runSqlUpdate(list);
            if ("true".equals(status)) {
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        }
        return getErrReturnObject().setErrMsg("ûѡɾԱ").toString();
    }

    /**
     * 
     *
     * @return
     */
    public String check() {
        String tnoticeid = content.getString("tnoticeid");
        boolean fischeck = content.getBooleanValue("fischeck");//Ƿ񷢲
        SQLFactory sqlFactory = null;
        if (fischeck) {
            sqlFactory = new SQLFactory(this, "ͨ淢");
            sqlFactory.addParameter("checkby", username);
        } else {
            sqlFactory = new SQLFactory(this, "ͨȡ");
        }
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tnoticeid", tnoticeid);
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equalsIgnoreCase(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ͨɾ
     *
     * @return
     */
    public String delete() {
        long tnoticeid = content.getLongValue("tnoticeid");
        if (dbConnect.runSqlQuery("select * from tnotice where siteid='" + siteid + "' and fstatus='½' and tnoticeid=" + tnoticeid).isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰ״̬ɾ").toString();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ͨɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tnoticeid", tnoticeid);

        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        String tnoticeid = content.getString("tnoticeid");
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        SQLFactory factory = new SQLFactory(this, "ûб", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ѯͨԱ
     *
     * @return
     */
    public String query_noticeuserList() {
        String tnoticeid = content.getString("tnoticeid");
        /**
         *
         */
        String[] sortfield = {"t1.tnotice_usersid"};
        String sort = getSort(sortfield, "t1.tnotice_usersid");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("t3.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("t3.fbrand like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ѯͨԱ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tnoticeid", tnoticeid);
        sqlFactory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

}
