package com.cnd3b.restcontroller.customer.tagents;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3BReturnObject_Err;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class tagents extends Controller {
    public tagents(JSONObject content) {
        super(content);
    }

    /**
     * ҵѯ
     *
     * @return
     */
    public String query_enterpriseAgentsMain() {
        SQLFactory agentsql = new SQLFactory(this, "ѯ");
        agentsql.addParameter("siteid", siteid);
        agentsql.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(agentsql.getSQL());
        for (Row row : rows) {
            row.put("saleprodclass", JSONArray.parseArray(row.getString("saleprodclass")));
            row.put("attinfos", getAttachmentUrl("tagents", String.valueOf(tagentsid)));
            SQLFactory modifyapp = new SQLFactory(this, "޸ѯ");
            modifyapp.addParameter("siteid", siteid);
            modifyapp.addParameter("tagentsid", tagentsid);
            Rows modifyapprows = dbConnect.runSqlQuery(modifyapp.getSQL());
            row.put("fisauthenticating", modifyapprows.isEmpty() ? 0 : 1);

            //޸ѯ
            Rows tagents_msgchangeappRows = dbConnect.runSqlQuery("select fchangemsg,ftype,tagents_msgchangappid,changedate from tagents_msgchangeapp where fstatus='' and siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
            if (tagents_msgchangeappRows.isEmpty()) {
                row.put("msgchangeapp", "{}");
            } else {
                String ftype = tagents_msgchangeappRows.get(0).getString("ftype");
                String fchangemsg = tagents_msgchangeappRows.get(0).getString("fchangemsg");
                long tagents_msgchangappid = tagents_msgchangeappRows.get(0).getLong("tagents_msgchangappid");
                String changedate = tagents_msgchangeappRows.get(0).getString("changedate");
                JSONObject msgchangeappObject = new JSONObject();
                msgchangeappObject.put("ftype", ftype);
                msgchangeappObject.put("fchangemsg", JSONObject.parseObject(fchangemsg));
                msgchangeappObject.put("tagents_msgchangappid", tagents_msgchangappid);
                msgchangeappObject.put("changedate", changedate);
                row.put("msgchangeapp", msgchangeappObject);
            }
        }
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ̻Ϣ
     *
     * @return
     */
    public String modify_enterpriseAgent() throws D3bException, P2Exception {
        String ftype = content.getString("ftype");//
        /**
         * ֻи˲ſɽ̻֤
         */
        JSONArray dataArray = content.getJSONArray("data");
        for (Object o : dataArray) {
            JSONObject fchangemsgObject = (JSONObject) o;
            fchangemsgObject.checkStringLength("fagentnum", "tagents.fagentnum", "̱");//̱
            fchangemsgObject.checkStringLength("fagentname", "tagents.fagentname", "");//
            fchangemsgObject.checkStringLength("fagentshortname", "tagents.fagentshortname", "̼");//̼
            fchangemsgObject.checkStringLength("fcontact", "tagents.fcontact", "ϵ");//ϵ
            fchangemsgObject.checkStringLength("faddress", "tagents.faddress", "ϸַ");//ַ
            fchangemsgObject.checkStringLength("fphonenumber", "tagents.fphonenumber", "ϵʽ");//ֻ
            fchangemsgObject.checkStringLength("fwechatno", "tagents.fwechatno", "΢ź");//΢ź
            fchangemsgObject.checkStringLength("femail", "tagents.femail", "");//
            fchangemsgObject.checkStringLength("fdutyparagraph", "tagents.fdutyparagraph", "ͳһ");//ͳһô
            fchangemsgObject.checkStringLength("fbrand", "tagents.fbrand", "ӪƷ");//ͳһô
            fchangemsgObject.checkStringLength("fintroduction", "tagents.fintroduction", "˾");//˾

            if (fchangemsgObject.containsKey("saleprodclass") && !isJSONArray(fchangemsgObject.getString("saleprodclass"))) {
                return new D3BReturnObject_Err().setErrMsg("saleprodclassЧJSONArrayʽ").toString();
            }

            dbConnect.runSqlUpdate("update tagents_msgchangeapp set fstatus='' where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and fstatus=''");

            PaoSetRemote tagents_msgchangeappSet = getP2ServerSystemPaoSet("tagents_msgchangeapp");
            PaoRemote tagents_msgchangeapp = tagents_msgchangeappSet.addAtEnd();
            tagents_msgchangeapp.setValue("fchangemsg", fchangemsgObject.toJSONString(), 11L);
            tagents_msgchangeapp.setValue("fstatus", "", 11L);
            tagents_msgchangeapp.setValue("ftype", ftype, 11L);
            tagents_msgchangeapp.setValue("siteid", siteid, 11L);
            tagents_msgchangeapp.setValue("tagentsid", tagentsid, 11L);
            tagents_msgchangeapp.setValue("tenterprise_userid", userid, 11L);
            tagents_msgchangeapp.setValue("changeby", username, 11L);//޸
            tagents_msgchangeapp.setValue("changedate", sysdate, 11L);//޸ʱ

            if ("ͨ޸".equalsIgnoreCase(ftype)) {
                PaoSetRemote tagentsSet = tagents_msgchangeapp.getPaoSet("$tagents", "tagents", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
                if (!tagentsSet.isEmpty()) {
                    PaoRemote tagents = tagentsSet.getPao(0);
                    List<String> fieldlist = Arrays.asList(getTableColumns("tagents"));
                    Iterator it = fchangemsgObject.keySet().iterator();
                    while (it.hasNext()) {
                        String key = (String) it.next();
                        if (fieldlist.contains(key.toLowerCase())) {
                            if (getTableColumnType("tagents", key.toLowerCase()).equals("datetime")) {
                                tagents.setValue(key, fchangemsgObject.getDate(key.toLowerCase()), 11L);
                            } else {
                                tagents.setValue(key, fchangemsgObject.getString(key.toLowerCase()), 11L);
                            }
                        }
                    }
                    tagents_msgchangeapp.setValue("fstatus", "", 11L);
                    tagents_msgchangeapp.setValue("checkby", username, 11L);
                    tagents_msgchangeapp.setValue("checkdate", sysdate, 11L);
                    createSystemMessage("̻", "̻֪ͨ", "̻Ϣ޸˳ɹ", userid);
                }
            }
            tagents_msgchangeappSet.save();
            tagents_msgchangeappSet.close();
        }
        return getSucReturnObject().toString();
    }

    /**
     * ̻бѯ
     *
     * @return
     */
    public String query_cooperation() {
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fcontact like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fbrand like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
//            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
//                where.append(" and(");
//                where.append("t1.ftype ='").append(whereObject.getString("ftype")).append("' ");
//                where.append(")");
//            }
            if (whereObject.containsKey("fstatus") && !"".equals(whereObject.getString("fstatus"))) {
                where.append(" and(");
                where.append("t1.fstatus ='").append(whereObject.getString("fstatus")).append("' ");
                where.append(")");
            }
        }

        SQLFactory sqlFactory = new SQLFactory(this, "бѯ", pageSize, pageNumber, "t1.createdate");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        RowsMap brandlogoRowsMap = getAttachmentUrl("tagents", rows.toArrayList("tcooperationagentsid"), "brandlogo");
        for (Row row : rows) {
            row.put("attinfos", brandlogoRowsMap.get(row.getString("tcooperationagentsid")));
            row.put("saleprodclass", JSONArray.parseArray(row.getString("saleprodclass")));
        }
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool().toString();
    }

    /**
     * 
     * tagentsIDΪ뷽tcooperationagentsidΪṩ
     *
     * @return
     * @throws P2Exception
     */
    public String apply_cooperation() throws P2Exception {
        long tcooperationagentsid = content.getLong("tcooperationagentsid");//ṩID
        if (tcooperationagentsid == tagentsid) {
            return getErrReturnObject().setErrMsg("޷Լϵ").toString();
        }
        if (getAgent(tagentsid).getString("ftype").equals("")) {
            return getErrReturnObject().setErrMsg("Ƚ̻֤").toString();
        }
        if (dbConnect.runSqlQuery("select *from tagents where tagentsid='" + tcooperationagentsid + "'").isEmpty()) {
            return getErrReturnObject().setErrMsg("Ҳú̻Ϣ").toString();
        }
//        int ftype = content.getInteger("ftype");//
        PaoSetRemote tagents_cooperationSet = getP2ServerSystemPaoSet("tagents_cooperation", "tagentsid='" + tcooperationagentsid + "' and tcooperationagentsid='" + tagentsid + "'");
        if (!tagents_cooperationSet.isEmpty()) {
            if ("".equals(tagents_cooperationSet.getPao(0).getString("fstatus"))) {
                return getErrReturnObject().setErrMsg("ǰѽϵ").toString();
            } else {
                return getErrReturnObject().setErrMsg("").toString();
            }
        }
        PaoRemote tagents_cooperation = tagents_cooperationSet.addAtEnd();
        tagents_cooperation.setValue("siteid", siteid, 11L);
        tagents_cooperation.setValue("createby", username, 11L);
        tagents_cooperation.setValue("createdate", sysdate, 11L);
//        tagents_cooperation.setValue("ftype", ftype, 11L);//Ҫtcooperationagentsid̻ã1Σ2Σ3˫
        tagents_cooperation.setValue("fstatus", "", 11L);//״̬
        tagents_cooperation.setValue("tagentsid", tcooperationagentsid, 11L);
        tagents_cooperation.setValue("tcooperationagentsid", tagentsid, 11L);
        tagents_cooperationSet.save();

        createSystemMessageByAgentsid("̻", "֪ͨ", getAgent(tagentsid).getString("fbrand") + "뽨ϵ", tagents_cooperation.getUniqueIDValue(), "tagents_cooperation", tcooperationagentsid);
        return getSucReturnObject().toString();
    }

    /**
     * ϵ,
     * tagentsIDΪṩtcooperationagentsidΪ뷽
     *
     * @return
     */
    public String cooperation() throws P2Exception {
        long tcooperationagentsid = content.getLong("tcooperationagentsid");//ID
//        int ftype = content.getInteger("ftype");//
        PaoSetRemote tagents_cooperationSet = getP2ServerSystemPaoSet("tagents_cooperation", "tagentsid='" + tagentsid + "' and tcooperationagentsid='" + tcooperationagentsid + "'");

        PaoRemote tagents_cooperation = tagents_cooperationSet.getPao(0);
        tagents_cooperation.setValue("createby", username, 11L);
        tagents_cooperation.setValue("createdate", sysdate, 11L);
//        tagents_cooperation.setValue("ftype", ftype, 11L);//Ҫtcooperationagentsid̻ã1Σ2Σ3˫
        tagents_cooperation.setValue("fstatus", "", 11L);//״̬

        if (dbConnect.runSqlQuery("select *from tagents_cooperation where tagentsid='" + tcooperationagentsid + "' and tcooperationagentsid='" + tagentsid + "'").isEmpty()) {
            PaoRemote tagents_cooperation2 = tagents_cooperationSet.addAtEnd();
            tagents_cooperation2.setValue("siteid", siteid, 11L);
            tagents_cooperation2.setValue("createby", username, 11L);
            tagents_cooperation2.setValue("createdate", sysdate, 11L);
//            tagents_cooperation2.setValue("ftype", ftype == 1 ? 2 : (ftype == 2 ? 1 : 0), 11L);//Ҫtcooperationagentsid̻ã1Σ2Σ3˫
            tagents_cooperation2.setValue("fstatus", "", 11L);//״̬
            tagents_cooperation2.setValue("tagentsid", tcooperationagentsid, 11L);
            tagents_cooperation2.setValue("tcooperationagentsid", tagentsid, 11L);
        }
        tagents_cooperationSet.save();
        createSystemMessageByAgentsid("̻", "º֪ͨ", "" + getAgent(tagentsid).getString("fbrand") + "ºɹ", tcooperationagentsid);
        Row agentrow = getAgent(tcooperationagentsid);
        if (agentrow != null) {
            createSystemMessageByAgentsid("̻", "º֪ͨ", "" + agentrow.getString("fbrand") + "ºɹ", tagentsid);
        }
        return getSucReturnObject().toString();
    }

    /**
     * ʽ
     *
     * @return
     * @throws P2Exception
     */
    public String update_cooperation() throws P2Exception {
        long tcooperationagentsid = content.getLong("tcooperationagentsid");//ID
        int ftype = content.getInteger("ftype");//
        PaoSetRemote tagents_cooperationSet = getP2ServerSystemPaoSet("tagents_cooperation", "tagentsid='" + tagentsid + "' and tcooperationagentsid='" + tcooperationagentsid + "'");

        PaoRemote tagents_cooperation = tagents_cooperationSet.getPao(0);
        tagents_cooperation.setValue("ftype", ftype, 11L);//Ҫtcooperationagentsid̻ã1Σ2Σ3˫
        tagents_cooperationSet.save();

        Row row = getMainUser(tagents_cooperation.getLong("tcooperationagentsid"));
        if (row != null) {
            createSystemMessageByAgentsid("̻", "ʽ֪ͨ", "" + getAgent(tcooperationagentsid).getString("fbrand") + "ʽɹ", userid);
        }
        return getSucReturnObject().toString();
    }

    /**
     * ϵ
     * tagentsIDΪṩtcooperationagentsidΪ뷽
     *
     * @return
     */
    public String delete_cooperation() throws P2Exception {
        long tcooperationagentsid = content.getLong("tcooperationagentsid");//ID

        SQLFactory sqlFactory = new SQLFactory(this, "ϵ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tcooperationagentsid", tcooperationagentsid);
        String status = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(status)) {
            Row row = getMainUser(tcooperationagentsid);
            if (row != null) {
                createSystemMessageByAgentsid("̻", "ȡ֪ͨ", "" + getAgent(tcooperationagentsid).getString("fbrand") + "ȡɹ", userid);
            }
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * Ϣѯ
     *
     * @return
     */
    public String query_cooperationAgentsMain() {

        SQLFactory sql = new SQLFactory(this, "ѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tcooperationagentsid", content.getString("tagentsid"));
        sql.addParameter("tagentsid", tagentsid);
        sql.addParameter_SQL("orderby", " t2.changedate DESC,t1.changedate DESC");
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        for (Row row : rows) {
            row.put("saleprodclass", JSONArray.parseArray(row.getString("saleprodclass")));
            row.put("attinfos", getAttachmentUrl("tagents", content.getString("tagentsid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }


    /**
     * ѯ̻˺б
     *
     * @return
     */
    public String query_CooperationAgentUsers() {
        String tagentsid = content.getString("tagentsid");
        SQLFactory sqlFactory = new SQLFactory(this, "˺бѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        String sql = sqlFactory.getSQL();
        Rows rows = dbConnect.runSqlQuery(sql);
        if (content.getBooleanValue("hasAdministrator")) {
            SQLFactory factory = new SQLFactory(this, "˺бѯ_˺");
            factory.addParameter("siteid", siteid);
            factory.addParameter("tagentsid", tagentsid);
            Rows tempRows = dbConnect.runSqlQuery(factory.getSQL());
            if (!tempRows.isEmpty()) {
                rows.add(0, tempRows.get(0));
            }
        }

        RowsMap attinfosMap = getAttachmentUrl("tenterprise_users", rows.toArrayList("tenterprise_userid"), "headportrait");
        for (Row row : rows) {
            String tenterprise_userid = row.getString("tenterprise_userid");
            row.put("attinfos", attinfosMap.get(tenterprise_userid));
        }
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }

}
