package com.cnd3b.restcontroller.enterprise.tagents;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3BReturnObject_Err;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.Arrays;
import java.util.Iterator;
import java.util.List;

public class tagents extends Controller {
    public tagents(JSONObject content) {
        super(content);
    }


    /**
     * ̻бѯ
     *
     * @return
     */
    public String query_singleagentsList() {
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t2.fname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
        }
        /**
         * ֤״̬ŵһ
         */
        SQLFactory singleagentSql = new SQLFactory(this, "̻бѯ", pageSize, pageNumber, "(case when exists(select *from tagents_msgchangeapp where ftype='̻֤' and fstatus='' and tagentsid=t1.tagentsid) then '֤' else 'δ֤' end),t1.tagentsid desc");
        singleagentSql.addParameter("siteid", siteid);
        singleagentSql.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(singleagentSql.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ̻бѯ
     *
     * @return
     */
    public String query_agentsList() {

        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fcontact like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fbrand like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("notin") && !"".equals(whereObject.getString("notin"))) {
                JSONObject notinObject = whereObject.getJSONObject("notin");
                if (notinObject.containsKey("tactivity_agentmsg")) {
                    JSONObject tactivity_agentmsgObject = notinObject.getJSONObject("tactivity_agentmsg");
                    long tactivityid = tactivity_agentmsgObject.getLong("tactivityid");
                    where.append(" and not exists( select * from tactivity_agentmsg where siteid='" + siteid + "' " +
                            "and tactivityid='" + tactivityid + "' and tagentsid=t1.tagentsid ) ");
                }
            }
            if (whereObject.getBooleanValue("iscreatelive")) {
                //Ƿչֱ
                where.append(" and not exists( select * from tlive where siteid='" + siteid + "' " +
                        "and isnull(tactivityid,0)='' and tagentsid=t1.tagentsid) ");
            }
        }
//        Rows tRows = dbConnect.runSqlQuery(" SELECT DISTINCT tagentsid FROM tlive");
//        SQLFactory sqlFactory2 = new SQLFactory(this, "ѯظ̻");
//        Rows tRows2 = dbConnect.runSqlQuery(sqlFactory2.getSQL());
//        tRows.addAll(tRows2);
        SQLFactory agentsql = new SQLFactory(this, "֤̻бѯ", pageSize, pageNumber, "t1.tagentsid desc");
        agentsql.addParameter("siteid", siteid);
        agentsql.addParameter_SQL("where", where);
        //ųѾֱ̻
//        agentsql.addParameter_in("tagentsid",tRows.toArrayList("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(agentsql.getSQL());

        String sql = agentsql.getSQL();

        SQLFactory agentchecksql = new SQLFactory(this, "̻֤ʱѯ");
        agentchecksql.addParameter("siteid", siteid);
        agentchecksql.addParameter_in("tagentsid", rows.toArrayList("tagentsid"));
        RowsMap agentcheckrowsMap = dbConnect.runSqlQuery(agentchecksql.getSQL()).toRowsMap("tagentsid");

        for (Row row : rows) {
            row.put("saleprodclass", JSONArray.parseArray(row.getString("saleprodclass")));
            String tagentsid = row.getString("tagentsid");
            if (agentcheckrowsMap.containsKey(tagentsid)) {
                row.put("checkdate", agentcheckrowsMap.get(tagentsid).get(0).getString("checkdate"));
            } else {
                row.put("checkdate", row.getString("createdate"));
            }
        }

        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }


    /**
     * ҵѯ
     *
     * @return
     */
    public String query_agentsMain() {
        long tagentsid = content.getLong("tagentsid");
        SQLFactory sql = new SQLFactory(this, "̻ѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        for (Row row : rows) {
            row.put("saleprodclass", JSONArray.parseArray(row.getString("saleprodclass")));
            row.put("attinfos", getAttachmentUrl("tagents", String.valueOf(tagentsid), "brandlogo"));

            //޸ѯ
            Rows tagents_msgchangeappRows = dbConnect.runSqlQuery("select fchangemsg,ftype,tagents_msgchangappid,changedate from tagents_msgchangeapp where fstatus='' and siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
            if (tagents_msgchangeappRows.isEmpty()) {
                row.put("msgchangeapp", "{}");
            } else {
                String ftype = tagents_msgchangeappRows.get(0).getString("ftype");
                String fchangemsg = tagents_msgchangeappRows.get(0).getString("fchangemsg");
                long tagents_msgchangappid = tagents_msgchangeappRows.get(0).getLong("tagents_msgchangappid");
                String changedate = tagents_msgchangeappRows.get(0).getString("changedate");
                JSONObject msgchangeappObject = new JSONObject();
                msgchangeappObject.put("ftype", ftype);
                msgchangeappObject.put("fchangemsg", JSONObject.parseObject(fchangemsg));
                msgchangeappObject.put("tagents_msgchangappid", tagents_msgchangappid);
                msgchangeappObject.put("changedate", changedate);
                row.put("msgchangeapp", msgchangeappObject);
            }
        }
        return getSucReturnObject().setData(rows).toString();
    }


    /**
     * ̻Ϣ
     *
     * @return
     */
    public String modify_agent() throws D3bException, P2Exception {
        long tagentsid = content.getLong("tagentsid");//id,0ʾ
        String ftype = content.getString("ftype");//̻֤ͨ޸ġ
        /**
         * ֻи˲ſɽ̻֤
         */
        JSONArray dataArray = content.getJSONArray("data");
        for (Object o : dataArray) {
            JSONObject fchangemsgObject = (JSONObject) o;
            fchangemsgObject.checkStringLength("fagentnum", "tagents.fagentnum", "̱");//̱
            fchangemsgObject.checkStringLength("fagentname", "tagents.fagentname", "");//
            fchangemsgObject.checkStringLength("fagentshortname", "tagents.fagentshortname", "̼");//̼
            fchangemsgObject.checkStringLength("fcontact", "tagents.fcontact", "ϵ");//ϵ
            fchangemsgObject.checkStringLength("faddress", "tagents.faddress", "ϸַ");//ַ
            fchangemsgObject.checkStringLength("fphonenumber", "tagents.fphonenumber", "ϵʽ");//ֻ
            fchangemsgObject.checkStringLength("fwechatno", "tagents.fwechatno", "΢ź");//΢ź
            fchangemsgObject.checkStringLength("femail", "tagents.femail", "");//
            fchangemsgObject.checkStringLength("fdutyparagraph", "tagents.fdutyparagraph", "ͳһ");//ͳһô
            fchangemsgObject.checkStringLength("fbrand", "tagents.fbrand", "ӪƷ");//ͳһô
            if (fchangemsgObject.containsKey("saleprodclass") && !isJSONArray(fchangemsgObject.getString("saleprodclass"))) {
                return new D3BReturnObject_Err().setErrMsg("saleprodclassЧJSONArrayʽ").toString();
            }
            if (tagentsid > 0) {
                dbConnect.runSqlUpdate("update tagents_msgchangeapp set fstatus='' where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and fstatus=''");
            }

            long tagents_msgchangappid = 0;
            PaoSetRemote tagents_msgchangeappSet = getP2ServerSystemPaoSet("tagents_msgchangeapp");
            PaoRemote tagents_msgchangeapp = tagents_msgchangeappSet.addAtEnd();
            tagents_msgchangappid = tagents_msgchangeapp.getUniqueIDValue();
            tagents_msgchangeapp.setValue("fchangemsg", fchangemsgObject.toJSONString(), 11L);
            tagents_msgchangeapp.setValue("fstatus", "", 11L);
            tagents_msgchangeapp.setValue("ftype", ftype, 11L);
            if (tagentsid == 0) {
                PaoSetRemote tagentsSet = tagents_msgchangeapp.getPaoSet("$tagents", "tagents");
                PaoRemote tagents = tagentsSet.addAtEnd();
                tagents.setValue("siteid", siteid, 11L);//ҵID
                tagents.setValue("createdate", getDateTime(), 11L);//¼ʱ
                tagents.setValue("fphonenumber", fchangemsgObject.getString("fphonenumber"), 11L);
                tagents.setValue("fjoindate", getDateTime(), 11L);
                tagents.setValue("ftype", "", 11L);
                tagentsid = tagents.getUniqueIDValue();
                content.put("tagentsid", tagentsid);
            }
            tagents_msgchangeapp.setValue("tagentsid", tagentsid, 11L);
            tagents_msgchangeapp.setValue("siteid", siteid, 11L);
            tagents_msgchangeapp.setValue("tenterprise_userid", userid, 11L);
            tagents_msgchangeapp.setValue("changeby", username, 11L);//޸
            tagents_msgchangeapp.setValue("changedate", sysdate, 11L);//޸ʱ
            tagents_msgchangeappSet.save();

            content.put("tagents_msgchangappid", tagents_msgchangappid);
            check_agentmodify();
        }
        return query_agentsMain();
    }


    /**
     * Ϣ޸
     *
     * @return
     * @throws D3bException
     * @throws P2Exception
     */
    public String check_agentmodify() throws P2Exception {
        long tagents_msgchangappid = content.getLong("tagents_msgchangappid");
        Rows rows = dbConnect.runSqlQuery("select ftype,fchangemsg,tagentsid from tagents_msgchangeapp where fstatus=''and siteid='" + siteid + "' and tagents_msgchangappid='" + tagents_msgchangappid + "'");
        if (rows.isEmpty()) {
            return getErrReturnObject().setErrMsg("Ҳָ").toString();
        }
        String ftype = rows.get(0).getString("ftype");
        String fchangemsg = rows.get(0).getString("fchangemsg");
        JSONObject changemsgObject = JSONObject.parseObject(fchangemsg);
        long tagentsid = rows.get(0).getLong("tagentsid");
        PaoSetRemote tagentsSet = getP2ServerSystemPaoSet("tagents", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
        if (!tagentsSet.isEmpty()) {
            PaoRemote tagents = tagentsSet.getPao(0);

            List<String> fieldlist = Arrays.asList(getTableColumns("tagents"));

            Iterator it = changemsgObject.keySet().iterator();

            while (it.hasNext()) {
                String key = (String) it.next();
                if (fieldlist.contains(key.toLowerCase())) {
                    if (getTableColumnType("tagents", key.toLowerCase()).equals("datetime")) {
                        tagents.setValue(key, changemsgObject.getDate(key.toLowerCase()), 11L);
                    } else {
                        tagents.setValue(key, changemsgObject.getString(key.toLowerCase()), 11L);
                    }
                }
            }
            if (ftype.equals("̻֤") || ftype.equals("")) {
                tagents.setValue("ftype", "ͨ", 11L);
            }
            PaoSetRemote tagents_msgchangeappSet = tagents.getPaoSet("$tagents_msgchangeapp", "tagents_msgchangeapp", "tagents_msgchangappid=" + tagents_msgchangappid);
            tagents_msgchangeappSet.getPao(0).setValue("fstatus", "", 11L);
            tagents_msgchangeappSet.getPao(0).setValue("checkby", username, 11L);
            tagents_msgchangeappSet.getPao(0).setValue("checkdate", sysdate, 11L);
            tagentsSet.save();
            tagentsSet.close();

            if (ftype.equals("̻֤") || ftype.equals("")) {
                createSystemMessageByAgentsid("̻", "̻֪ͨ", "ϲ̻פ˳ɹҽ߳Ϊ", tagentsid);
            } else {
                createSystemMessageByAgentsid("̻", "̻֪ͨ", "̻Ϣ޸˳ɹ", tagentsid);
            }
        }
        return getSucReturnObject().toString();
    }


    /**
     * ҵ̵ɾ
     *
     * @return
     */
    public String delete_agent() {
        String tagentsid = content.getString("tagentsid");
        if (!dbConnect.runSqlQuery("select *from tuserrequestlog where siteid='" + siteid + "' and tagentsid='" + tagentsid + "'").isEmpty()) {
            return getErrReturnObject().setErrMsg("ǰ̻зʼ¼ɾͣ").toString();
        }

        SQLFactory sqlFactory = new SQLFactory(this, "̻ɾ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        String result = dbConnect.runSqlUpdate(sqlFactory.getSQL());
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ҵ̵ͣ
     *
     * @return
     */
    public String use_agent() {
        int fisused = content.getInteger("fisused");
        long tagentsid = content.getLong("tagentsid");
        String result = dbConnect.runSqlUpdate("update tagents set fisused=" + fisused + " where siteid='" + siteid + "' and tagentsid='" + tagentsid + "'");
        if ("true".equals(result)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(result).toString();
        }
    }

    /**
     * ҵԱ˺Ϣѯ
     *
     * @return
     */
    public String query_agentUsers() {
        SQLFactory sql = new SQLFactory(this, "̻˺бѯ");
        sql.addParameter("siteid", siteid);
        sql.addParameter("tagentsid", content.getString("tagentsid"));
        Rows rows = dbConnect.runSqlQuery(sql.getSQL());
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }


    /**
     * ̻
     *
     * @return
     * @throws P2Exception
     */
    public String addHotAgents() throws P2Exception {

        String fname = content.getString("fname");
        String ftype = content.getString("ftype");
        String frownum = content.getString("frownum");

        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("texcellentagents");

            PaoRemote paoRemote = paoSetRemote.addAtEnd();
            paoRemote.setValue("texcellentagentsid", paoRemote.getUniqueIDValue(), 11L);
            paoRemote.setValue("fname", fname);
            paoRemote.setValue("ftype", ftype);
            paoRemote.setValue("frownum", frownum);
            paoRemote.setValue("siteid", siteid);
            paoSetRemote.save();
            return getSucReturnObject().toString();


    }

    /**
     * ̻
     *
     * @return
     * @throws P2Exception
     */
    public String updateHotAgents() throws P2Exception {
        String texcellentagentsid = content.getString("texcellentagentsid");
        String fname = content.getString("fname");
        String ftype = content.getString("ftype");
        String frownum = content.getString("frownum");

        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("texcellentagents", " texcellentagentsid = '" + texcellentagentsid + "'");
        if (!paoSetRemote.isEmpty()) {
            PaoRemote paoRemote = paoSetRemote.getPao(0);

            paoRemote.setValue("fname", fname);
            paoRemote.setValue("ftype", ftype);
            paoRemote.setValue("frownum", frownum);
            paoRemote.setValue("siteid", siteid);
            paoSetRemote.save();
            return getSucReturnObject().toString();
        } else {


            return getErrReturnObject().setErrMsg("δҵӦ").toString();
        }
    }

    /**
     * ɾ̻
     *
     * @return
     */
    public String deleteHotAgents() {
        String texcellentagentsid = content.getString("texcellentagentsid");

        String sql = "DELETE FROM texcellentagents WHERE texcellentagentsid = '" + texcellentagentsid + "'";

        String response = dbConnect.runSqlUpdate(sql);
        if (response.equals("true")) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().toString();
        }

    }


    /**
     * ȡ̻б
     *
     * @return
     */
    public String getHotAgentsList() {
        SQLFactory agentlistSql = null;
        if (content.containsKey("ftype") && !"".equals(content.getString("ftype"))) {
            String ftype = content.getString("ftype");
            agentlistSql = new SQLFactory(this, "̻б", pageSize, pageNumber, "t1.frownum");
            agentlistSql.addParameter("ftype", ftype);
            agentlistSql.addParameter("siteid", siteid);
        } else {
            agentlistSql = new SQLFactory(this, "̻б_ȫ", pageSize, pageNumber, "t1.ftype,t1.frownum");
            agentlistSql.addParameter("siteid", siteid);
        }
        Rows rows = dbConnect.runSqlQuery(agentlistSql.getSQL());
        RowsMap map = getAttachmentUrl("texcellentagents", rows.toArrayList("texcellentagentsid"));
        for (Row row : rows) {
            row.put("attinfos", map.get(row.getString("texcellentagentsid")));

        }
        return getSucReturnObject().setData(rows).saveToDataPool(10).toString();


    }

}
