package com.cnd3b.restcontroller.customer.live;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;
import com.cnd3b.utility.polyv.Polyv;
import net.polyv.live.v1.entity.channel.operate.LiveChannelInfoResponse;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.ArrayList;
import java.util.HashMap;

public class live extends Controller {
    public live(JSONObject content) {
        super(content);
    }

    /**
     * ȡƵб
     *
     * @return
     */
    public String getLiveCategory() {
        Polyv polyv = new Polyv();
        HashMap<Integer, String> map = polyv.listCategory();
        JSONArray array = new JSONArray();
        for (int id : map.keySet()) {
            JSONObject object = new JSONObject();
            object.put("categoryId", id);
            object.put("categoryName", map.get(id));
            array.add(object);
        }
        return getSucReturnObject().setData(array).toString();
    }

    /**
     * ֱбѯ
     *
     * @return
     */
    public String queryChannelList() {
        /**
         *
         */
        String[] sortfield = {"t1.createdate desc"};
        String sort = getSort(sortfield, "t1.createdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.channelname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("categoryid") && !"".equals(whereObject.getString("categoryid"))) {
                where.append(" and(");
                where.append("t1.categoryid ='").append(whereObject.getString("categoryid")).append("' ");
                where.append(")");
            }
        }

        SQLFactory costhead = new SQLFactory(this, "ֱбѯ", pageSize, pageNumber, sort);
        costhead.addParameter("siteid", siteid);
        costhead.addParameter("tagentsid", tagentsid);
        costhead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(costhead.getSQL());
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ֱѯ
     *
     * @return
     */
    public String queryChannelMain() {
        long tliveid = content.getLong("tliveid");
        try {
            Rows channelidrows = dbConnect.runSqlQuery("select channelid from tlive where tliveid='" + tliveid + "'");
            if (!channelidrows.isEmpty()) {
                String channelid = channelidrows.get(0).getString("channelid");
                Polyv polyv = new Polyv();
                LiveChannelInfoResponse liveChannelInfoResponse = polyv.getChannelInfo(channelid);
                if (liveChannelInfoResponse != null) {
                    String channelpasswd = liveChannelInfoResponse.getChannelPasswd();
                    dbConnect.runSqlUpdate("update tlive set channelpasswd='" + channelpasswd + "' where tliveid='" + tliveid + "'");
                }
            }
        } catch ( Exception e) {
            e.printStackTrace();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ֱѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tliveid", tliveid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * չֱ
     *
     * @return
     */
    public String getLiveInfo() throws P2Exception {
        try {
            Rows channelidrows = dbConnect.runSqlQuery("select channelid from tlive where tagentsid='" + tagentsid + "' and categoryName = 'չֱ'");
            for (Row row : channelidrows) {
                String channelid = row.getString("channelid");
                Polyv polyv = new Polyv();
                LiveChannelInfoResponse liveChannelInfoResponse = polyv.getChannelInfo(channelid);
                if (liveChannelInfoResponse != null) {
                    String channelpasswd = liveChannelInfoResponse.getChannelPasswd();
                    dbConnect.runSqlUpdate("update tlive set channelpasswd='" + channelpasswd + "' where channelid='" + channelid + "'");
                }
            }
        } catch (Exception e) {
            e.printStackTrace();
        }
        SQLFactory sqlFactory = new SQLFactory(this, "չֱ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        if (rows.isEmpty()) {
            PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tliveapply", "siteid = '" + siteid + "' AND fissecret = 0 AND fstatus = ''");
            if (paoSetRemote.isEmpty()) {
                return getErrReturnObject().setErrCode(3).setErrMsg("ֱϢ").toString();
            } else {
                return getErrReturnObject().setErrCode(2).setErrMsg("ֱ").toString();
            }
        } else {
            return getSucReturnObject().setData(rows).toString();
        }
    }

    /**
     * չֱͳƣƵ
     *
     * @return
     */
    public String getLiveDataCount() {
        String channelid = content.getString("channelid");
        JSONObject resultObject = new JSONObject();
        //ۿΣ
        long viewCounts = getCount("ۿ", "num", channelid);
        resultObject.put("viewCounts", viewCounts);
        //ۿʱӣ
        long viewDuration = getCount("ۿʱ", "num", channelid);
        resultObject.put("viewDuration", viewDuration);
        //ۿˣ
        long viewers = getCount("ۿ", "num", channelid);
        resultObject.put("viewers", viewers);
        //˾ۿΣ
        resultObject.put("viewCountsAvg", viewers == 0 ? 0 : viewCounts / viewers);
        //˾ۿʱӣ
        resultObject.put("viewDurationAvg", viewers == 0 ? 0 : viewDuration / viewers);

        return getSucReturnObject().setData(resultObject).toString();
    }

    /**
     * ֱͳƣΣ
     *
     * @return
     * @throws P2Exception
     */
    public String getLiveDataCountForSession() throws P2Exception {
        String sessionid = content.getString("sessionid");
        int livepv = 0;
        int liveuv = 0;
        int duration = 0;
        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tlive_sessiondata", "sessionid = '" + sessionid + "'");
        if (!paoSetRemote.isEmpty()) {
            PaoRemote paoRemote = paoSetRemote.getPao(0);
            //
            livepv = paoRemote.getInt("livepv");
            //˴
            liveuv = paoRemote.getInt("liveuv");
            //ʱ
            duration = paoRemote.getInt("duration");
        }

        JSONObject resultObject = new JSONObject();

        resultObject.put("viewers", livepv);
        resultObject.put("viewCounts", liveuv);
        resultObject.put("viewDuration", duration);
        resultObject.put("viewCountsAvg", livepv == 0 ? 0 : liveuv / livepv);
        resultObject.put("viewDurationAvg", livepv == 0 ? 0 : duration / livepv);

        return getSucReturnObject().setData(resultObject).toString();
    }


    /**
     * ֱûۿб
     *
     * @return
     */
    public String getLiveUserList() {
        String channelid = content.getString("channelid");
        String sessionid = content.getString("sessionid");

        SQLFactory sqlFactory = new SQLFactory(this, "ֱûۿб", pageSize, pageNumber, "t1.createdtime");
        sqlFactory.addParameter("channelid", channelid);
        sqlFactory.addParameter("sessionid", sessionid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }


    /**
     * ֱбѯ
     *
     * @return
     */
    public String getLiveSessionList() {

        String channelid = content.getString("channelid");
        SQLFactory sqlFactory = new SQLFactory(this, "ֱбѯ", pageSize, pageNumber, "createdate");
        sqlFactory.addParameter("channelid", channelid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ˽ֱ
     *
     * @return
     */
    public String getSYLiveInfo() throws P2Exception {
        SQLFactory sqlFactory = new SQLFactory(this, "˽ֱ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        if (rows.isEmpty()) {
            PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tliveapply", "siteid = '" + siteid + "' and tagentsid='" + tagentsid + "' AND fissecret = 1 AND fstatus = ''");
            if (paoSetRemote.isEmpty()) {
                return getErrReturnObject().setErrCode(3).setErrMsg("ֱϢ").toString();
            } else {
                return getErrReturnObject().setErrCode(2).setErrMsg("ֱ").toString();
            }
        } else {
            return getSucReturnObject().setData(rows).toString();
        }


    }

    /**
     * ˽ֱͳƣƵ
     *
     * @return
     */
    public String getSYLiveDataCount() {
        String channelid = content.getString("channelid");
        JSONObject resultObject = new JSONObject();
        //ۿΣ
        long viewCounts = getCount("ۿ", "num", channelid);
        resultObject.put("viewCounts", viewCounts);
        //ۿʱӣ
        long viewDuration = getCount("ۿʱ", "num", channelid);
        resultObject.put("viewDuration", viewDuration);
        //ۿˣ
        long viewers = getCount("ۿ", "num", channelid);
        resultObject.put("viewers", viewers);
        //˾ۿΣ
        resultObject.put("viewCountsAvg", viewers == 0 ? 0 : viewCounts / viewers);
        //˾ۿʱӣ
        resultObject.put("viewDurationAvg", viewers == 0 ? 0 : viewDuration / viewers);

        return getSucReturnObject().setData(resultObject).toString();
    }

    /**
     * ˽ֱͳƣΣ
     *
     * @return
     * @throws P2Exception
     */
    public String getSYLiveDataCountForSession() throws P2Exception {
        String sessionid = content.getString("sessionid");
        int livepv = 0;
        int liveuv = 0;
        int duration = 0;
        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tlive_sessiondata", "sessionid = '" + sessionid + "'");
        if (!paoSetRemote.isEmpty()) {
            PaoRemote paoRemote = paoSetRemote.getPao(0);
            //
            livepv = paoRemote.getInt("livepv");
            //˴
            liveuv = paoRemote.getInt("liveuv");
            //ʱ
            duration = paoRemote.getInt("duration");
        }

        JSONObject resultObject = new JSONObject();

        resultObject.put("viewers", livepv);
        resultObject.put("viewCounts", liveuv);
        resultObject.put("viewDuration", duration);
        resultObject.put("viewCountsAvg", livepv == 0 ? 0 : liveuv / livepv);
        resultObject.put("viewDurationAvg", livepv == 0 ? 0 : duration / livepv);

        return getSucReturnObject().setData(resultObject).toString();
    }


    /**
     * ˽ֱûۿб
     *
     * @return
     */
    public String getSYLiveUserList() {
        String channelid = content.getString("channelid");
        String sessionid = content.getString("sessionid");

        SQLFactory sqlFactory = new SQLFactory(this, "˽ֱûۿб", pageSize, pageNumber, "t1.createdtime");
        sqlFactory.addParameter("channelid", channelid);
        sqlFactory.addParameter("sessionid", sessionid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ˽ֱ
     *
     * @return
     */
    public String applySYLive() throws P2Exception {
        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tliveapply", "siteid = '" + siteid + "' and tagentsid='" + tagentsid + "' AND fissecret = 1 AND fstatus = ''");
        if (paoSetRemote.isEmpty()) {
            PaoRemote paoRemote = paoSetRemote.addAtEnd();
            paoRemote.setValue("CHANGEBY", username, 11L);
            paoRemote.setValue("CHANGEDATE", getDateTime_Str(), 11L);
            paoRemote.setValue("CREATEBY", username, 11L);
            paoRemote.setValue("CREATEDATE", getDateTime_Str(), 11L);
            paoRemote.setValue("FISSECRET", true, 11L);
            paoRemote.setValue("FSTATUS", "", 11L);
            paoRemote.setValue("FNOTES", "˽ֱ", 11L);
            paoRemote.setValue("SITEID", siteid);
            paoRemote.setValue("TAGENTSID", tagentsid);
            paoSetRemote.save();
            return getSucReturnObject().setData("˽ֱɹ").toString();
        } else {
            return getErrReturnObject().setErrMsg("˽ֱ").toString();
        }
    }

    /**
     * ˽ֱбѯ
     *
     * @return
     */
    public String getSYLiveSessionList() {
        String channelid = content.getString("channelid");
        SQLFactory sqlFactory = new SQLFactory(this, "˽ֱбѯ", pageSize, pageNumber, "createdate");
        sqlFactory.addParameter("channelid", channelid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ȡ
     *
     * @param SQLMODELNAME SQL
     * @param fieldname    ȡݵֶ
     * @return
     */
    public long getCount(String SQLMODELNAME, String fieldname, String channelid) {
        SQLFactory sqlFactory = new SQLFactory(this, SQLMODELNAME);
        sqlFactory.addParameter("channelid", channelid);
        Rows rows = sqlFactory.runSqlQuery();
        return rows.isEmpty() ? 0 : rows.get(0).getLong(fieldname);
    }

    /**
     * ȡʵʱֱۿ
     */
    public String getRealTimeViewers() {
        String channelid = content.getString("channelid");
        //String sql = "SELECT [count] FROM tlive_usercount WHERE [time]='" + getDateTime_Str() + "' AND channelid='" + channelid + "'";
        String sql = "select channelid,count as fcustcount from (select ROW_NUMBER()over(partition by t1.channelid order by t1.time desc)as num,t1.channelid,(t1.count+t1.fadjustcount) as count from tlive_usercount t1 where t1. channelid='" + channelid + "')t where t.num=1";
        System.err.println(sql);
        Rows rows = dbConnect.runSqlQuery(sql);
        JSONObject resultObject = new JSONObject();
        resultObject.put("count", rows.isEmpty() ? 0 : rows.get(0).getLong("fcustcount"));
        return getSucReturnObject().setData(resultObject).toString();
    }

    /**
     * ȡʵʱб
     *
     * @return
     */
    public String getRealTimeViewerList() {
        String channelid = content.getString("channelid");
        Long lastmodified = getDateTime().getTime() / 1000 - 5 * 60;
        System.err.println(lastmodified);
        SQLFactory sqlFactory = new SQLFactory(this, "ʵʱб", pageSize, pageNumber, "t1.tlive_viewlogid DESC");
        sqlFactory.addParameter("channelid", channelid);
        sqlFactory.addParameter("lastmodified", lastmodified * 1000);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ȡʵʱֱб
     *
     * @return
     */
    public String getRealTimeMessageList() {
        String channelid = content.getString("channelid");
//        Long time = getDateTime().getTime() - 1*60*1000;
        SQLFactory sqlFactory = new SQLFactory(this, "ʵʱб", pageSize, pageNumber, "t1.time DESC");
        sqlFactory.addParameter("channelid", channelid);
//        sqlFactory.addParameter("time", time);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ȡֱб˽չᣩ
     *
     * @return
     */
    public String getCooperationAgentsLiveList() {

        //ѯ̻id
        String sql = "SELECT tcooperationagentsid FROM tagents_cooperation WHERE tagentsid = '" + tagentsid + "' AND fstatus = '';";
        Rows rows = dbConnect.runSqlQuery(sql);
        ArrayList<String> tagentsidList = new ArrayList<>();
        for (Row row : rows) {
            tagentsidList.add(row.getString("tcooperationagentsid"));
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ֱб");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_in("tagentsidList", tagentsidList);
        Rows agentRows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        for (Row row : agentRows) {
            //ۿΣ
            String channelid = row.getString("channelid");
            //ۿˣ
            long viewers = getCount("ۿ", "num", channelid);
            row.put("viewers", viewers);
        }


        return getSucReturnObject().setData(agentRows).toString();
    }


}
