package com.cnd3b.restcontroller.customer.usercenter.teammsg;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.utility.Encryption;
import com.cnd3b.utility.Sms;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

import java.util.*;

public class teammsg extends Controller {
    public teammsg(JSONObject content) {
        super(content);
    }

    /**
     * ˺бѯ
     *
     * @return
     */
    public String query_userList() {
        SQLFactory sqlFactory = new SQLFactory(this, "˺бѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());

        SQLFactory subusersql = new SQLFactory(this, "¼˺Ųѯ");
        subusersql.addParameter("siteid", siteid);
        subusersql.addParameter_in("fparentid", rows.toArrayList("tenterprise_userid"));

        RowsMap map = dbConnect.runSqlQuery(subusersql.getSQL()).toRowsMap("fparentid");

        RowsMap attinfosMap = getAttachmentUrl("tenterprise_users", rows.toArrayList("tenterprise_userid"), "headportrait");
        for (Row row : rows) {
            String tenterprise_userid = row.getString("tenterprise_userid");
            Rows subuserrows = map.get(tenterprise_userid);
            String[] subusers = subuserrows.toArray("tenterprise_userid");
            row.put("subusers", subusers);
            for (Row subuserrow : subuserrows) {
                subuserrow.put("attinfos", attinfosMap.get(subuserrow.getString("tenterprise_userid")));
            }
            row.put("subusermsgs", subuserrows);
            row.put("attinfos", attinfosMap.get(tenterprise_userid));
        }
        return getSucReturnObject().setData(rows).saveToDataPool().toString();
    }



    /**
     * ˺Ϣ޸
     *
     * @return
     */
    public String update_userMsg() throws D3bException, P2Exception {
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//˺ID
        String fname = content.getString("fname", "tenterprise_users.fname", "˺");//
        String frole = content.getString("frole", "tenterprise_users.frole", "/ְλ");//ְλ
        String fphonenumber = content.getString("fphonenumber", "tenterprise_users.fphonenumber", "ֻ");//ֻ
        boolean fisused = content.getBoolean("fisused");
        JSONArray subusersArray = content.getJSONArray("subusers");

        boolean toBeAdded = false;
        PaoSetRemote tenterprise_usersSet = getP2ServerSystemPaoSet("tenterprise_users", "siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tenterprise_userid='" + tenterprise_userid + "'");
        PaoRemote pao = null;
        if (tenterprise_userid <= 0 || tenterprise_usersSet.isEmpty()) {
            pao = tenterprise_usersSet.addAtEnd();
            pao.setValue("tagentsid", tagentsid, 11L);
            pao.setValue("siteid", siteid, 11L);
            pao.setValue("fusertype", "", 11L);
            tenterprise_userid = pao.getUniqueIDValue();
            toBeAdded = true;
        } else {
            pao = tenterprise_usersSet.getPao(0);
        }
        pao.setValue("fisused", fisused, 11L);
        pao.setValue("fname", fname, 11L);
        pao.setValue("frole", frole, 11L);
        pao.setValue("fphonenumber", fphonenumber, 11L);
        pao.setValue("changeby", username, 11L);
        pao.setValue("changedate", getDateTime(), 11L);

        /**
         * ѯ¼˺ţ粻ڣ¼˺
         */
        PaoSetRemote tenterprise_userdetailSet = pao.getPaoSet("$tenterprise_userdetail", "tenterprise_userdetail", "siteid=:siteid and fparentid=:tenterprise_userid");
        HashMap<String, PaoRemote> paoMap = getPaoMap(tenterprise_userdetailSet, "fsubid");

        /**
         * жǷҪɾ
         */
        ArrayList<String> donotdeleteid = new ArrayList<>();

        Iterator subuserlistit = subusersArray.iterator();
        ArrayList<String> distinctid = new ArrayList<>();
        while (subuserlistit.hasNext()) {
            String fsubid = String.valueOf(subuserlistit.next());
            if (distinctid.contains(fsubid)) {
                continue;
            } else {
                distinctid.add(fsubid);
            }
            PaoRemote subuserpao = null;
            if (!paoMap.containsKey(fsubid)) {
                subuserpao = tenterprise_userdetailSet.addAtEnd();
                subuserpao.setValue("siteid", siteid, 11L);//ҵID
                subuserpao.setValue("fparentid", tenterprise_userid, 11L);//˺ID
                subuserpao.setValue("fsubid", fsubid, 11L);//¼˺ID
                subuserpao.setValue("createby", username, 11L);//¼
                subuserpao.setValue("createdate", getDateTime(), 11L);//¼ʱ
            } else {
                donotdeleteid.add(fsubid);
                subuserpao = paoMap.get(fsubid);
            }
            subuserpao.setValue("changeby", username, 11L);//޸
            subuserpao.setValue("changedate", getDateTime(), 11L);//޸ʱ
        }
        /**
         * ɾ
         */
        for (String fsubid : paoMap.keySet()) {
            if (!donotdeleteid.contains(fsubid)) {
                if (!paoMap.get(fsubid).isModified()) {
                    paoMap.get(fsubid).delete();
                }
            }
        }
        tenterprise_usersSet.save();

        //޸˺ȻϢ
        if (parameter.userIdList.containsKey(tenterprise_userid)) {
            Row row = parameter.userIdList.get(tenterprise_userid);
            row.put("fname", fname);
            parameter.userIdList.put(tenterprise_userid, row);
            dbConnect.runSqlUpdate("update timdialogusers set fname='" + fname + "'where siteid='" + siteid + "' and tenterprise_userid='" + tenterprise_userid + "'");
        }
        if (toBeAdded) {
            createSystemMessage("Ŷ", "ŶӼ֪ͨ", "ϲ" + getAgent(tagentsid).getString("fbrand") + "Ŷ", tenterprise_userid);
        }
        return getSucReturnObject().toString();
    }

    /**
     * ת˺Ź
     *
     * @return
     */
    public String changeAdministrator() throws D3bException, P2Exception {
        String fpassword = content.getString("fpassword");//֤
        long tenterprise_userid = content.getLong("tenterprise_userid");//ת˺ID

        int resultcode;
        if (!parameter.changeAdministrator_passwordmap.containsKey(tenterprise_userid)) {
            resultcode = 1;//ûлȡ֤
        } else if (parameter.changeAdministratorpassword_date.get(tenterprise_userid).before(Calendar.getInstance().getTime())) {
            resultcode = 2;//֤ʧЧ
        } else {
            //ϵͳ֤
            String syspassword = parameter.changeAdministrator_passwordmap.get(tenterprise_userid);
            if (fpassword.equals(new Encryption().Encode_MD5(syspassword))) {
                resultcode = 0;//֤ȷ
            } else {
                resultcode = 3;//֤
            }
        }
        if (resultcode == 0) {
            parameter.changeAdministrator_passwordmap.remove(tenterprise_userid);
            parameter.changeAdministratorpassword_date.remove(tenterprise_userid);

            String sql1 = "update tenterprise_users set fisadministrator=0 where siteid='" + siteid + "' and tenterprise_userid=" + userid;
            String sql2 = "update tenterprise_users set fisadministrator=1 where siteid='" + siteid + "' and tenterprise_userid=" + tenterprise_userid;
            ArrayList<String> sqllist = new ArrayList<>();
            sqllist.add(sql1);
            sqllist.add(sql2);
            String status = dbConnect.runSqlUpdate(sqllist);
            if ("true".equals(status)) {
                /**
                 * ͳɹתϢ
                 */
                createSystemMessage("Ŷ", "Ա", "ĹȨת", userid);
                createSystemMessage("Ŷ", "Ա", "ѳΪǰŶӹ", tenterprise_userid);

                /**
                 * ¹Ա
                 */
                if (parameter.userIdList.containsKey(userid)) {
                    Row oldadministrator = parameter.userIdList.get(userid);
                    oldadministrator.put("fisadministrator", 0);
                    parameter.userIdList.put(userid, oldadministrator);
                }
                if (parameter.userIdList.containsKey(tenterprise_userid)) {
                    Row newadministrator = parameter.userIdList.get(tenterprise_userid);
                    newadministrator.put("fisadministrator", 1);
                    parameter.userIdList.put(tenterprise_userid, newadministrator);
                }
                return getSucReturnObject().toString();
            } else {
                return getErrReturnObject().setErrMsg(status).toString();
            }
        } else {
            String msg = "";
            if (resultcode == 1) {
                msg = "Ȼȡ֤룡";
            } else if (resultcode == 2) {
                msg = "֤ʧЧ»ȡ";
            } else if (resultcode == 3) {
                msg = "Ч֤룡";
            }
            return getErrReturnObject().setErrMsg(msg).toString();
        }
    }


    /**
     * ת֤ȡ
     *
     * @return
     */
    public String getPassword() throws D3bException, P2Exception {
        long tenterprise_userid = content.getLong("tenterprise_userid");//ת˺ID
        String fphonenumber = getUser(tenterprise_userid).getString("fphonenumber");

        String password = createPassWord();
        parameter.changeAdministrator_passwordmap.put(tenterprise_userid, password);
        Calendar calendar = Calendar.getInstance();
        calendar.add(Calendar.MINUTE, 5);
        parameter.changeAdministratorpassword_date.put(tenterprise_userid, calendar.getTime());
        if (parameter.isdebug()) {
            return getSucReturnObject().setData("֤룺" + password).toString();
        } else {
            Sms sms = new Sms();
            sms.sendOutMsg(fphonenumber, password);
            return getSucReturnObject().setData("֤ѷͣעգ").toString();
        }
    }

    private String createPassWord() {
        String allChar = "1234567890";
        StringBuffer sb = new StringBuffer();
        Random random = new Random();
        for (int i = 0; i < 6; i++) {
            sb.append(allChar.charAt(random.nextInt(allChar.length())));
        }
        if (parameter.changeAdministrator_passwordmap.containsValue(sb.toString())) {
            return createPassWord();
        } else {
            return sb.toString();
        }
    }

    /**
     * ŶӳԱͣ
     *
     * @return
     */
    public String updateusedstate() throws D3bException, P2Exception {
        long tenterprise_userid = content.getLongValue("tenterprise_userid");//˺ID
        boolean fisused = content.getBooleanValue("fisused");//Ƿ
        String status = dbConnect.runSqlUpdate("update tenterprise_users set fisused='" + (fisused ? 1 : 0) + "' where siteid='" + siteid + "' and tagentsid='" + tagentsid + "' and tenterprise_userid='" + tenterprise_userid + "'");
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }

    /**
     * ŶӼ
     *
     * @return
     */
    public String checkEntryTeamApply() throws P2Exception {
        boolean isPass = content.getBooleanValue("isPass");
        //̻Ŷid
        long tagentteamapplyid = content.getLong("tagentteamapplyid");
        //ҵ˺űid
        long tenterprise_userid = content.getLong("tenterprise_userid");
        PaoSetRemote paoSetRemote = getP2ServerSystemPaoSet("tagentteamapply", "tagentteamapplyid = '" + tagentteamapplyid + "'");
        if (!paoSetRemote.isEmpty()) {
            PaoRemote paoRemote = paoSetRemote.getPao(0);
            PaoSetRemote paoSetRemote_tenterprise = paoRemote.getPaoSet("tenterprise_users", "tenterprise_users", "tenterprise_userid = '" + tenterprise_userid + "'");
            if (paoSetRemote_tenterprise.isEmpty()) {
                return getErrReturnObject().setErrMsg("δҵϢ").toString();
            }
            long oldtagentsid = paoSetRemote_tenterprise.getPao(0).getLong("tagentsid");
            PaoRemote paoRemote_tenterprise = paoSetRemote_tenterprise.getPao(0);
            //ֻܾ̻Ŷ
            if (!isPass) {
                paoRemote.setValue("fstatus", "ܾ", 11L);
                paoSetRemote.save();
                createSystemMessage("Ŷ", "ŶӼ֪ͨ", "벻ͨ", tenterprise_userid);
                return getSucReturnObject().setData("ܾɹ").toString();
            } else {
                paoRemote.setValue("fstatus", "", 11L);
                boolean fissaveagentmsg = paoRemote.getBoolean("fissaveagentmsg");//Ƿǰ̻Ϣ
                if (fissaveagentmsg) {
                    PaoRemote pao = paoSetRemote_tenterprise.addAtEnd();
                    pao.setValue("SITEID", paoRemote_tenterprise.getString("SITEID"), 11L);
                    pao.setValue("FNAME", paoRemote_tenterprise.getString("FNAME"), 11L);
                    pao.setValue("FPHONENUMBER", paoRemote_tenterprise.getString("FPHONENUMBER"), 11L);
                    pao.setValue("fusertype", "");
                    pao.setValue("fisadministrator", false, 11L);
                    pao.setValue("tagentsid", tagentsid, 11L);
                    paoRemote.setValue("fuserid", pao.getUniqueIDValue(), 11L);
                    tenterprise_userid = pao.getUniqueIDValue();
                } else {
                    paoRemote_tenterprise.setValue("tagentsid", tagentsid, 11L);
                    paoRemote_tenterprise.setValue("fisadministrator", false, 11L);
                }
                paoSetRemote.save();
                if (!fissaveagentmsg) {
                    SQLFactory deleteagentsql = new SQLFactory(this, "̻ɾ");
                    deleteagentsql.addParameter("siteid", siteid);
                    deleteagentsql.addParameter("tagentsid", oldtagentsid);
                    dbConnect.runSqlUpdate(deleteagentsql.getSQL());
                }
                createSystemMessage("Ŷ", "ŶӼ֪ͨ", "ϲ" + getAgent(tagentsid).getString("fbrand"), tenterprise_userid);
                return getSucReturnObject().setData("˳ɹ").toString();
            }
        } else {
            return getErrReturnObject().setErrMsg("δҵ¼").toString();
        }


    }

    /**
     * ȡŶӼб
     *
     * @return
     */
    public String getEntryTeamApplyList() {
        SQLFactory sqlFactory = new SQLFactory(this, "ŶӼб", pageSize, pageNumber, "createdate");
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("siteid", siteid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            row.put("attinfos", getAttachmentUrl("tenterprise_users", row.getString("tenterprise_userid")));
        }

        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }
}
