package com.cnd3b.restcontroller.enterprise.bannermag;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.D3bException;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import p2.pao.PaoRemote;
import p2.pao.PaoSetRemote;
import p2.util.P2Exception;

public class bannermag extends Controller {
    public bannermag(JSONObject content) {
        super(content);
    }

    /**
     * ֲλѯ
     *
     * @return
     */
    public String query_bannerlocationlist() {
        SQLFactory locationSQL = new SQLFactory(this, "ֲλѯ");
        locationSQL.addParameter("siteid", siteid);
        Rows locationrows = dbConnect.runSqlQuery(locationSQL.getSQL());

        SQLFactory bannerSQl = new SQLFactory(this, "ֲбѯ");
        bannerSQl.addParameter("siteid", siteid);
        bannerSQl.addParameter_in("tbannerlocationid", locationrows.toArrayList("tbannerlocationid"));
        RowsMap bannermap = dbConnect.runSqlQuery(bannerSQl.getSQL()).toRowsMap("tbannerlocationid");
        for (Row locationrow : locationrows) {
            Rows bannerRows = bannermap.get(locationrow.getString("tbannerlocationid"));
            for (Row bannerrow : bannerRows) {
                bannerrow.put("attinfos", getAttachmentUrl("tbannermag", bannerrow.getString("tbannermagid")));
            }
            locationrow.put("banner", bannerRows);
        }
        return getSucReturnObject().setData(locationrows).saveToDataPool(10).toString();
    }

    /**
     * ޸ֲͼ
     *
     * @return
     * @throws P2Exception
     */
    public String insertormodify_bannermag() throws D3bException, P2Exception {
        long tbannerlocationid = content.getLong("tbannerlocationid");
        long tbannermagid = content.getLong("tbannermagid");//0
        boolean fisused = content.getBooleanValue("fisused");
        String fhyperlink = content.getString("fhyperlink", "tbannermag.fhyperlink", "URL");
        String flinktype = content.getString("flinktype");
        String fdatatable = content.getString("fdatatable");
        long fdataid = content.getLongValue("fdataid");

        PaoSetRemote tbannermagSet = getP2ServerSystemPaoSet("tbannermag", "siteid='" + siteid + "' and tbannermagid='" + tbannermagid + "'");
        PaoRemote tbannermag = null;
        if (tbannermagid <= 0 || tbannermagSet.isEmpty()) {
            tbannermag = tbannermagSet.addAtEnd();
            tbannermag.setValue("tbannerlocationid", tbannerlocationid, 11L);//ҵID
            tbannermag.setValue("siteid", siteid, 11L);//ҵID
            tbannermag.setValue("createby", username, 11L);//¼
            tbannermag.setValue("createdate", sysdate, 11L);//¼ʱ
            tbannermagid = tbannermag.getUniqueIDValue();
        } else {
            tbannermag = tbannermagSet.getPao(0);
        }
        tbannermag.setValue("fisused", fisused, 11L);//Ƿ
        tbannermag.setValue("flinktype", flinktype, 11L);//
        if ("DATA".equals(flinktype)) {
            tbannermag.setValue("fdatatable", fdatatable, 11L);//ͨ
            tbannermag.setValue("fdataid", fdataid, 11L);//Ƿ˽
        } else if ("URL".equals(flinktype)) {
            tbannermag.setValue("fhyperlink", fhyperlink, 11L);//url
        }
        tbannermag.setValue("changeby", username, 11L);//޸
        tbannermag.setValue("changedate", sysdate, 11L);//޸ʱ
        tbannermagSet.save();

        SQLFactory bannerSQl = new SQLFactory(this, "ֲѯ");
        bannerSQl.addParameter("siteid", siteid);
        bannerSQl.addParameter("tbannerlocationid", tbannerlocationid);
        bannerSQl.addParameter("tbannermagid", tbannermagid);
        Row row = dbConnect.runSqlQuery(0, bannerSQl.getSQL());
        return getSucReturnObject().setData(row).toString();
    }

    public String delete_bannermag() throws P2Exception {
        long tbannerlocationid = content.getLong("tbannerlocationid");
        long tbannermagid = content.getLong("tbannermagid");//0
        String status = dbConnect.runSqlUpdate("delete from tbannermag where siteid='" + siteid + "' and tbannerlocationid='" + tbannerlocationid + "' and tbannermagid='" + tbannermagid + "'");
        if ("true".equals(status)) {
            return getSucReturnObject().toString();
        } else {
            return getErrReturnObject().setErrMsg(status).toString();
        }
    }
}
