package com.cnd3b.restcontroller.enterprise.data;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.parameter.parameter;
import com.cnd3b.common.websocket.WebClientSocket;

import java.util.ArrayList;
import java.util.Map;
import java.util.concurrent.ConcurrentHashMap;

public class analysis extends Controller {
    public analysis(JSONObject content) {
        super(content);
    }


    /**
     * ȡûʵʱ,ûtenterprise_users̻tagents
     *
     * @return
     */
    public String getOnLineUserList() {
        ArrayList<String> userList = new ArrayList<>();
        for (long userid : parameter.websocketClients.keySet()) {
            userList.add(String.valueOf(userid));
        }
        SQLFactory sqlFactory = new SQLFactory(this, "ûʵʱ", pageSize, pageNumber, "t1.tenterprise_userid");
        sqlFactory.addParameter_in("tenterprise_userid", userList);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            row.put("loginindate", getDateTime_Str(getLoginDate(row.getLong("tenterprise_userid"))));
        }
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ȡ̻̻
     *
     * @return
     */
    public String getOnLineMerchantList() {
        ArrayList<String> userList = new ArrayList<>();
        for (long userid : parameter.websocketClients.keySet()) {
            userList.add(String.valueOf(userid));
        }
        SQLFactory sqlFactory = new SQLFactory(this, "̻ʵʱ", pageSize, pageNumber, "t1.tagentsid");
        sqlFactory.addParameter_in("tenterprise_userid", userList);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        for (Row row : rows) {
            row.put("saleprodclass", JSONArray.parse(row.getString("saleprodclass")));
        }
        return getSucReturnObject().setDataByPaging(rows).preloading(1).toString();
    }

    /**
     * ȡֱ̻Ϣ
     *
     * @return
     */
    public String getLiveInfoCount() {

        JSONObject resultObject = new JSONObject();

        //̻
        SQLFactory countKaiBoSql = new SQLFactory(this, "̻");
        Rows countRowsKaiBo = countKaiBoSql.runSqlQuery();
        resultObject.put("countAgent", countRowsKaiBo.isEmpty() ? 0 : countRowsKaiBo.get(0).getInteger("fcount"));

        //ֱ
        SQLFactory countLiveSql = new SQLFactory(this, "ֱ");
        Rows countRowsLive = countLiveSql.runSqlQuery();
        resultObject.put("countUser", countRowsLive.isEmpty() ? 0 : countRowsLive.get(0).getInteger("fcount"));

        //Ϣ
        SQLFactory countGXSql = new SQLFactory(this, "Ϣ");
        Rows countRowsGX = countGXSql.runSqlQuery();
        resultObject.put("countGX", countRowsGX.isEmpty() ? 0 : countRowsGX.get(0).getInteger("fcount"));

        return getSucReturnObject().setData(resultObject).toString();
    }

}