package com.cnd3b.restcontroller.enterprise.notice_agent;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;
import com.cnd3b.common.data.db.DataPool;

import java.util.ArrayList;

public class notice_agent extends Controller {
    public notice_agent(JSONObject content) {
        super(content);
    }

    /**
     * ͨбѯ
     *
     * @return
     */
    public String query_noticeList() {
        /**
         *
         */
        String[] sortfield = {"t1.fisontop desc,t1.checkdate desc"};
        String sort = getSort(sortfield, "t1.fisontop desc,t1.checkdate desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.ftype like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t1.fsummary like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fbrand like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and t1.ftype='").append(whereObject.getString("ftype")).append("'");
            }
        }
        SQLFactory noticehead = new SQLFactory(this, "ͨбѯ", pageSize, pageNumber, sort);
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter_SQL("where", where);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());

        ArrayList<String> tnoticeidlist = rows.toArrayList("tnoticeid");
        //ͨ渽ѯ
        RowsMap attinfocountmap = getAttachmentQty("tnotice", tnoticeidlist);
        //ͨͼѯ
        RowsMap noticecovermap = getAttachmentUrl("tnotice", tnoticeidlist, "cover");

        for (Row row : rows) {
            String tnoticeid = row.getString("tnoticeid");
            row.put("fattachmentcount", attinfocountmap.containsKey(tnoticeid) ? attinfocountmap.get(tnoticeid).getRow(0).getInteger("fattachmentcount") : 0);
            row.put("attinfos", noticecovermap.get(tnoticeid));
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setDataByPaging(rows, sortfield).setFinalDo(DataPool.defaultdatalife, 1);
    }

    /**
     * ͨѯ
     *
     * @return
     */
    public String query_noticeMain() {
        String tnoticeid = content.getString("tnoticeid");
        SQLFactory noticehead = new SQLFactory(this, "ͨѯ");
        noticehead.addParameter("siteid", siteid);
        noticehead.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(noticehead.getSQL());

        Rows attinfosRows = getAttachmentUrl("tnotice", tnoticeid);
        rows.get(0).put("attinfos", attinfosRows);
        rows.get(0).put("headportraiturl", getHeadPic(rows.get(0).getLong("tenterprise_userid")));
        return getSucReturnObject().setData(rows).toString();
    }

    /**
     * ûб
     *
     * @return
     */
    public String havereaduserlist() {
        String tnoticeid = content.getString("tnoticeid");
        /**
         *
         */
        String[] sortfield = {"t1.tenterprise_userid"};
        String sort = getSort(sortfield, "t1.tenterprise_userid");
        SQLFactory factory = new SQLFactory(this, "ûб", pageSize, pageNumber, sort);
        factory.addParameter("siteid", siteid);
        factory.addParameter("tnoticeid", tnoticeid);
        Rows rows = dbConnect.runSqlQuery(factory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).setFinalDo(DataPool.defaultdatalife, 1);
    }
}
