package com.cnd3b.restcontroller.enterprise.supplyanddemand;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;

public class supplyanddemand extends Controller {
    public supplyanddemand(JSONObject content) {
        super(content);
    }

    /**
     * бѯ
     *
     * @return
     */
    public String query_supplyanddemandList() {
        /**
         *
         */
        String[] sortfield = {"case when t1.fstatus='ѽ'then 0 when t1.fstatus='Խ'then 1 else 2 end desc, t1.tsupplyanddemandid desc"};
        String sort = getSort(sortfield, "case when t1.fstatus='ѽ'then 0 when t1.fstatus='Խ'then 1 else 2 end desc, t1.tsupplyanddemandid desc");
        /**
         * 
         */
        StringBuffer where = new StringBuffer(" 1=1 ");
        if (content.containsKey("where")) {
            JSONObject whereObject = content.getJSONObject("where");
            if (whereObject.containsKey("condition") && !"".equals(whereObject.getString("condition"))) {
                where.append(" and(");
                where.append("t1.ftitle like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t2.fagentname like'%").append(whereObject.getString("condition")).append("%' ");
                where.append("or t3.fphonenumber like'%").append(whereObject.getString("condition")).append("%' ");
                where.append(")");
            }
            if (whereObject.containsKey("ftype") && !"".equals(whereObject.getString("ftype"))) {
                where.append(" and t1.ftype ='").append(whereObject.getString("ftype")).append("' ");
            }
            if (whereObject.containsKey("fissupply") && !"".equals(whereObject.getString("fissupply"))) {
                where.append(" and t1.fissupply =").append(whereObject.getBooleanValue("fissupply") ? 1 : 0);
            }
            if (whereObject.containsKey("fstatus") && !"".equals(whereObject.getString("fstatus"))) {
                where.append(" and t1.fstatus ='").append(whereObject.getString("fstatus")).append("' ");
            }
        }
        SQLFactory sqlFactory = new SQLFactory(this, "бѯ", pageSize, pageNumber, sort);
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter_SQL("where", where);

        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        return getSucReturnObject().setDataByPaging(rows).saveToDataPool().toString();
    }

    /**
     * ѯ
     *
     * @return
     */
    public String query_supplyanddemandMain() {
        long tsupplyanddemandid = content.getLong("tsupplyanddemandid");
        long tagentsid = content.getLong("tagentsid");

        SQLFactory sqlFactory = new SQLFactory(this, "ѯ");
        sqlFactory.addParameter("siteid", siteid);
        sqlFactory.addParameter("tagentsid", tagentsid);
        sqlFactory.addParameter("tsupplyanddemandid", tsupplyanddemandid);
        Rows rows = dbConnect.runSqlQuery(sqlFactory.getSQL());
        RowsMap attinfoRowsMap = getAttachmentUrl("tsupplyanddemand", rows.toArrayList("tsupplyanddemandid"));
        for (Row row : rows) {
            row.put("attinfos", attinfoRowsMap.get(row.getString("tsupplyanddemandid")));
            //ͷ
            row.put("headportraiturl", getHeadPic(row.getLong("tenterprise_userid")));
        }
        return getSucReturnObject().setData(rows).toString();
    }

}
