package com.cnd3b.restcontroller.publicmethod.bannermag;

import com.alibaba.fastjson.JSONObject;
import com.cnd3b.common.Controller;
import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.RowsMap;
import com.cnd3b.common.data.SQLFactory;

public class bannermag extends Controller {
    public bannermag(JSONObject content) {
        super(content);
    }

    /**
     * ֲλѯ
     *
     * @return
     */
    public String query_bannerlocationlist() {
        String fclienttype = content.getString("fclienttype");

        SQLFactory locationSQL = new SQLFactory(this, "ֲλѯ");
        locationSQL.addParameter("siteid", siteid);
        locationSQL.addParameter("fclienttype", fclienttype);
        Rows locationrows = dbConnect.runSqlQuery(locationSQL.getSQL());

        SQLFactory bannerSQl = new SQLFactory(this, "ֲѯ");
        bannerSQl.addParameter("siteid", siteid);
        bannerSQl.addParameter_in("tbannerlocationid", locationrows.toArrayList("tbannerlocationid"));
        RowsMap bannermap = dbConnect.runSqlQuery(bannerSQl.getSQL()).toRowsMap("tbannerlocationid");
        for (Row locationrow : locationrows) {
            Rows bannerRows = bannermap.get(locationrow.getString("tbannerlocationid"));
            for (Row bannerrow : bannerRows) {
                bannerrow.put("attinfos", getAttachmentUrl("tbannermag", bannerrow.getString("tbannermagid")));
            }
            locationrow.put("banner", bannerRows);
        }
        return getSucReturnObject().setData(locationrows).toString();
    }

    /**
     * ȡŻλֲͼ
     *
     * @return
     */
    public String getPortalBannerList() {
        //fclienttype:web,MOBILE
        String fclienttype = content.getString("fclienttype");
        SQLFactory locationSQL = new SQLFactory(this, "λѯ");
        locationSQL.addParameter("siteid", siteid);
        locationSQL.addParameter("fclienttype", fclienttype);
        Rows locationrows = dbConnect.runSqlQuery(locationSQL.getSQL());
        SQLFactory bannerSQl = new SQLFactory(this, "ֲͼѯ");
        bannerSQl.addParameter("siteid", siteid);
        bannerSQl.addParameter_in("tbannerlocationid", locationrows.toArrayList("tbannerlocationid"));
        RowsMap bannermap = dbConnect.runSqlQuery(bannerSQl.getSQL()).toRowsMap("tbannerlocationid");
        for (Row locationrow : locationrows) {
            Rows bannerRows = bannermap.get(locationrow.getString("tbannerlocationid"));
            for (Row bannerrow : bannerRows) {
                bannerrow.put("attinfos", getAttachmentUrl("tbannermag", bannerrow.getString("tbannermagid")));
            }
            locationrow.put("banner", bannerRows);
        }
        return getSucReturnObject().setData(locationrows).toString();
    }

}
