select channelid,
       t.tagentsid,
       t.fbrand,
       t.flocationclass,
       t.flocation,
       t.fintroduction,
       t.livestatus,
       count as fcustcount,
       count as viewers,
       t.channelcoverimageurl,
       t4.saleprodclass,
       t4.faddress,
       fliveshowurl
from (
         select ROW_NUMBER() over(partition by t1.channelid order by t1.time desc)as num,t1.channelid,
                t2.tagentsid,
                t2.livestatus,
                (t1.count + t1.fadjustcount)as count,
                t2.channelcoverimageurl,
                t2.fliveshowurl,
                t3.fbrand,
                t3.flocationclass,
                t3.flocation,
                t3.fintroduction
         from tlive_usercount t1
             inner join tlive t2
         on t1.channelid = t2.channelid and t2.livestatus = 'live'
             inner join tactivity_agentmsg t3 on t2.siteid = t3.siteid and t2.tagentsid = t3.tagentsid
         where t2.tactivityid = $tactivityid$
           and t2.siteid = $siteid$
     ) t
         left join tagents t4 on t4.tagentsid = t.tagentsid
where t.num = 1
  and t4.saleprodclass LIKE $saleprodclass$