declare @timdialogusersid bigint
set @timdialogusersid = (select isnull(MAX(timdialogusersid), 0) from timdialogusers)

insert into timdialogusers
(timdialogusersid, siteid, createby, changeby, createdate, changedate, rmkenable, fimdialognotes,fisremove,fname, tenterprise_userid,timdialogid,funreadmsgcount)
select @timdialogusersid + ROW_NUMBER() over (order by t1.fname),
       t1.siteid, $createby$, $createby$, getdate(), getdate(), 0, null,0,t1.fname, t1.tenterprise_userid,$timdialogid$,0
from tenterprise_users t1
where t1.siteid=$siteid$ and t1.tenterprise_userid in $tenterprise_userid$
and not exists(select * from timdialogusers where siteid=$siteid$ and timdialogid=$timdialogid$ and tenterprise_userid=t1.tenterprise_userid )

update timdialogusers set fisremove=0,createdate=getdate() where siteid=$siteid$ and timdialogid=$timdialogid$ and tenterprise_userid in $tenterprise_userid$