select timdialogusersid,
       t1.timdialogid,
       t1.tenterprise_userid,
       t1.fname,
       case when t1.tenterprise_userid = t2.tenterprise_userid then 1 else 0 end as fisadministrator,
       t4.fbrand,
       t4.fagentname
from timdialogusers t1
         inner join timdialog t2 on t1.siteid = t2.siteid and t1.timdialogid = t2.timdialogid
         inner join tenterprise_users t3 on t1.siteid=t3.siteid and t1.tenterprise_userid=t3.tenterprise_userid
         inner join tagents t4 on t3.siteid=t4.siteid and t3.tagentsid=t4.tagentsid
where t1.siteid = $siteid$
  and t1.timdialogid in $timdialogid$ and t1.fisremove=0
order by case when t1.tenterprise_userid = t2.tenterprise_userid then 1 else 0 end desc,t1.createdate