package com.cnd3b.utility.qywechat.app.drp;

import com.cnd3b.common.data.Row;
import com.cnd3b.common.data.Rows;
import com.cnd3b.common.data.db.DBConnect;
import com.cnd3b.utility.qywechat.base.AppRemote;

import java.util.HashMap;

public class DRP extends AppRemote {

    public static HashMap<String, HashMap<String, Object>> map;

    @Override
    public String switchTextMsg(String Content, String FromUserName, String ToUserName) {
        return createMsg.createTextMsg("˺ţ" + FromUserName + "ֵ" + Content, FromUserName, ToUserName);
    }

    @Override
    public String switchClickEventMsg(String EventKey, String FromUserName, String ToUserName) {
        StringBuffer returnmsg = new StringBuffer();
        switch (EventKey) {
            case "01": {
                // Ϣѯ
                try {
                    DBConnect connect = new DBConnect();
                    Rows rows = connect.runSqlQuery("select t1.fagentnum,t1.fagentname,t1.fprovince,t1.fcity,t1.fcounty from tagents t1 " +
                            " inner join tagents_users t2 on t1.fagentnum=t2.fagentnum " +
                            " inner join pp_hr t3 on t2.hrid=t3.hrid where t3.fqywechat='" + FromUserName + "'");
                    for (Row row : rows) {
                        returnmsg.append("ţ").append(row.getString("fagentnum")).append("\n");
                        returnmsg.append("ҵ΢źţ").append(FromUserName).append("\n");
                        returnmsg.append("ƣ").append(row.getString("fagentname")).append("\n");
                        returnmsg.append("ַ").append(row.getString("fprovince")).append(row.getString("fcity")).append(row.getString("fcounty")).append("\n");
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
                if ("".equals(returnmsg.toString())) {
                    return createMsg.createTextMsg(returnmsg.append("ѯ̻Ϣǰҵ΢źţ").append(FromUserName).toString(), FromUserName, ToUserName);
                } else {
                    return createMsg.createTextMsg(returnmsg.toString(), FromUserName, ToUserName);
                }
            }

            case "02": {
                // ˻Ϣ
                try {
                    DBConnect connect = new DBConnect();
                    Rows rows = connect.runSqlQuery("select t1.fagentnum from tagents_users t1 " +
                            " inner join pp_hr t2 on t1.hrid=t2.hrid where t2.fqywechat='" + FromUserName + "'");
                    for (Row row : rows) {
                        String fagentnum = row.getString("fagentnum");
                        returnmsg.append("̱:").append(fagentnum).append("\n");

                        Rows taccRows = connect.runSqlQuery("select *from taccbal_view where fagentnum='" + fagentnum + "'");
                        for (Row taccrow : taccRows) {
                            returnmsg.append(taccrow.getString("faccclsnum")).append(taccrow.getString("fname")).append("\n");
                            returnmsg.append("˻").append(taccrow.getDouble("fbalance")).append("\n");
                            returnmsg.append("öȣ").append(taccrow.getDouble("fcreditbal")).append("\n");
                            returnmsg.append("").append(taccrow.getDouble("ffreezamount")).append("\n");
                            returnmsg.append("ǰ").append(taccrow.getDouble("fcanuseamount")).append("\n");
                        }
                    }
                } catch (Exception e) {
                    e.printStackTrace();
                }
                if ("".equals(returnmsg.toString())) {
                    return createMsg.createTextMsg(returnmsg.append("ѯ˻Ϣ").append(FromUserName).toString(), FromUserName, ToUserName);
                } else {
                    return createMsg.createTextMsg(returnmsg.toString(), FromUserName, ToUserName);
                }
            }
            default:
                return createMsg.createTextMsg("İťֵ:" + EventKey, FromUserName, ToUserName);
        }
    }

    @Override
    public String switchImageMsg(String PicUrl, String MediaId, String FromUserName, String ToUserName) {
        return null;
        /*
         * String savefile = Parameter.SaveFile.Image + FromUserName + "_" +
         * Calendar.getInstance().getTimeInMillis() + ".jpg";// ļַ DownLoad downLoad
         * = new DownLoad(MediaId, savefile); return
         * createMsg.createTextMsg("ͼƬϴɹ\nС" + downLoad.getfilesize() + "\nַ" +
         * PicUrl, FromUserName, ToUserName);
         */
    }

    @Override
    public String switchVoiceMsg(String MediaId, String Format, String FromUserName, String ToUserName) {
        return null;
        /*
         * String savefile = Parameter.SaveFile.Voice + FromUserName + "_" +
         * Calendar.getInstance().getTimeInMillis() + "." + Format;// ļַ DownLoad
         * downLoad = new DownLoad(MediaId, savefile); return
         * createMsg.createTextMsg("Ƶϴɹ\nʽ" + Format + "\nС" +
         * downLoad.getfilesize(), FromUserName, ToUserName);
         */
    }

    @Override
    public String switchVideoMsg(String MediaId, String ThumbMediaId, String FromUserName, String ToUserName) {
        return null;
        /*
         * String savefile = Parameter.SaveFile.video + FromUserName + "_" +
         * Calendar.getInstance().getTimeInMillis() + ".rm";// ļַ DownLoad downLoad
         * = new DownLoad(MediaId, savefile); return
         * createMsg.createTextMsg("Ƶϴɹ\nС" + downLoad.getfilesize(), FromUserName,
         * ToUserName);
         */
    }

    @Override
    public String switchShortvideoMsg(String MediaId, String ThumbMediaId, String FromUserName, String ToUserName) {
        return null;
        /*
         * String savefile = Parameter.SaveFile.shortvideo + FromUserName + "_" +
         * Calendar.getInstance().getTimeInMillis() + ".rm";// ļַ DownLoad downLoad
         * = new DownLoad(MediaId, savefile);
         *
         * return createMsg.createTextMsg("СƵϴɹ\nС" + downLoad.getfilesize(),
         * FromUserName, ToUserName);
         */
    }

    @Override
    public String switchLocationMsg(String Location_X, String Location_Y, String Scale, String Label,
                                    String FromUserName, String ToUserName) {
        return createMsg.createTextMsg("γȣ" + Location_X + "\nȣ" + Location_Y + "\nλ" + Label, FromUserName,
                ToUserName);
    }

    /**
     * Աע/ȡע¼
     */
    @Override
    public String switchSubscribeEventMsg(String AgentID, String FromUserName, String ToUserName) {
        return null;
    }

    @Override
    public String switchViewEventMsg(String EventKey, String FromUserName, String ToUserName) {
        return null;
    }

    @Override
    public String switchScancode_pushEventMsg(String EventKey, String ScanType, String ScanResult, String FromUserName,
                                              String ToUserName) {

        String strs[] = ScanResult.split(",");
        return createMsg.createTextMsg("ͣ" + ScanType + "\nʽ" + strs[0] + "\nݣ" + strs[1], FromUserName,
                ToUserName);
    }

    @Override
    public String switchScancode_waitmsgEventMsg(String EventKey, String ScanType, String ScanResult,
                                                 String FromUserName, String ToUserName) {

        if (ScanType.equals("barcode")) {
            String strs[] = ScanResult.split(",");
            return createMsg.createTextMsg("ͣ" + ScanType + "\nʽ" + strs[0] + "\nݣ" + strs[1], FromUserName,
                    ToUserName);
        } else {
            return createMsg.createTextMsg("ͣ" + ScanType + "\nݣ" + ScanResult, FromUserName, ToUserName);
        }

    }

    @Override
    public String switchEnter_agentEventMsg(String EventKey, String FromUserName, String ToUserName) {
        return null;
        /*
         * Set<String> set = Parameter.entryDrpMap.keySet(); boolean flag = true; long
         * nowtime = System.currentTimeMillis(); if (set.contains(FromUserName)) { long
         * entrytime = Parameter.entryDrpMap.get(FromUserName); if (((nowtime -
         * entrytime) / (1000 * 60)) < 5) { flag = false; } } else {
         * Parameter.entryDrpMap.put(FromUserName, nowtime); } if (flag) { String p2dbconnectstring =
         * "ӭ˲ԶDRP΢ſͻˣǰͻʵֲѯϢϢͼϢȺDRPϵͳӣͼƬļƵ¼Ϣϴλõϴʵʱ¼ȹܡ"
         * ; return createMsg.createTextMsg("ãӭ٣\n" + p2dbconnectstring, FromUserName, ToUserName);
         * } else { return null; }
         */
    }

    /**
     * λ¼
     */
    @Override
    public String switchLocationEventMsg(String AgentID, String Latitude, String Longitude, String Precision,
                                         String FromUserName, String ToUserName) {
        return createMsg.createTextMsg("ǰλ\nγȣ" + Latitude + "\nȣ" + Longitude, FromUserName, ToUserName);

    }
}
