package com.cnd3b.utility.qywechat.base;

import com.cnd3b.utility.qywechat.tools.GetXmlValues;

/**
 * ûϢз
 *
 * @author Administrator
 */
public class ReturnHandle {
    String finalxml;
    String ToUserName;
    String FromUserName;
    String CreateTime;
    String Content;
    String MsgId;
    String AgentID;
    /**
     * xml
     */
    String returnXML;
    String Event;
    String EventKey;
    String PicUrl;
    String MediaId;
    String Format;
    String ThumbMediaId;
    String Location_X;
    String Location_Y;
    String Scale;
    String Label;
    String Latitude;
    String Longitude;
    String Precision;
    String ScanType;
    String ScanResult;

    public ReturnHandle(String finalxml) {
        this.finalxml = finalxml;
        ToUserName = GetXmlValues.get(finalxml, "ToUserName");
        FromUserName = GetXmlValues.get(finalxml, "FromUserName");
        CreateTime = GetXmlValues.get(finalxml, "CreateTime");
        AgentID = GetXmlValues.get(finalxml, "AgentID");
        if (getMsgType().equalsIgnoreCase(Parameter.MsgType.text)) {
            // text͵ϢȡӦĲ
            Content = GetXmlValues.get(finalxml, "Content");
            MsgId = GetXmlValues.get(finalxml, "MsgId");
            // ContentϢݣAgentIDӦIDжϽвͬķ
            switchTextMsg(Content);
        } else if (getMsgType().equalsIgnoreCase(Parameter.MsgType.location)) {
            // location͵ϢȡӦĲ
            Location_X = GetXmlValues.get(finalxml, "Location_X");
            Location_Y = GetXmlValues.get(finalxml, "Location_Y");
            Scale = GetXmlValues.get(finalxml, "Scale");
            Label = GetXmlValues.get(finalxml, "Label");
            MsgId = GetXmlValues.get(finalxml, "MsgId");
            switchLocationMsg(AgentID, Location_X, Location_Y, Scale, Label);
        } else if (getMsgType().equalsIgnoreCase(Parameter.MsgType.image)) {
            // image͵ϢȡӦĲ
            PicUrl = GetXmlValues.get(finalxml, "PicUrl");
            MediaId = GetXmlValues.get(finalxml, "MediaId");
            MsgId = GetXmlValues.get(finalxml, "MsgId");
            switchImageMsg(AgentID, PicUrl, MediaId);
        } else if (getMsgType().equalsIgnoreCase(Parameter.MsgType.voice)) {
            // voice͵ϢȡӦĲ
            MediaId = GetXmlValues.get(finalxml, "MediaId");
            Format = GetXmlValues.get(finalxml, "Format");
            MsgId = GetXmlValues.get(finalxml, "MsgId");
            switchVoiceMsg(AgentID, MediaId, Format);
        } else if (getMsgType().equalsIgnoreCase(Parameter.MsgType.video)) {
            // video͵ϢȡӦĲ
            MediaId = GetXmlValues.get(finalxml, "MediaId");
            ThumbMediaId = GetXmlValues.get(finalxml, "ThumbMediaId");
            MsgId = GetXmlValues.get(finalxml, "MsgId");
            switchVideoMsg(AgentID, MediaId, ThumbMediaId);
        } else if (getMsgType().equalsIgnoreCase(Parameter.MsgType.shortvideo)) {
            // shortvideo͵ϢȡӦĲ
            MediaId = GetXmlValues.get(finalxml, "MediaId");
            ThumbMediaId = GetXmlValues.get(finalxml, "ThumbMediaId");
            MsgId = GetXmlValues.get(finalxml, "MsgId");
            switchShortvideoMsg(AgentID, MediaId, ThumbMediaId);
        } else if (getMsgType().equalsIgnoreCase(Parameter.MsgType.event)) {
            Event = GetXmlValues.get(finalxml, "Event");// ʱͣť
            // event͵ϢȡӦĲ
            String eventtype = getEventType();
            if (eventtype.equalsIgnoreCase(Parameter.EventType.CLICK)) {// ť¼
                EventKey = GetXmlValues.get(finalxml, "EventKey");// ¼ֵݲֵͬӦӦ
                switchClickEventMsg(EventKey);
            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.subscribe)) {// Աע/ȡע¼
                switchSubscribeEventMsg();
            } else if (eventtype.equalsIgnoreCase(Parameter.EventType.LOCATION)) {// ϱλ¼
                Latitude = GetXmlValues.get(finalxml, "Latitude");
                Longitude = GetXmlValues.get(finalxml, "Longitude");
                Precision = GetXmlValues.get(finalxml, "Precision");
                switchLocationEventMsg(Latitude, Longitude, Precision);
            } else if (eventtype.equalsIgnoreCase(Parameter.EventType.VIEW)) {// ť¼
                EventKey = GetXmlValues.get(finalxml, "EventKey");// ַ
                switchViewEventMsg(EventKey);
            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.scancode_push)) {// ɨ¼¼
                EventKey = GetXmlValues.get(finalxml, "EventKey");
                ScanType = GetXmlValues.get(finalxml, "ScanType");
                ScanResult = GetXmlValues.get(finalxml, "ScanResult");
                switchScancode_pushEventMsg(EventKey, ScanType, ScanResult);
            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.scancode_waitmsg)) {// ɨ¼ҵϢСʾ¼
                EventKey = GetXmlValues.get(finalxml, "EventKey");
                ScanType = GetXmlValues.get(finalxml, "ScanType");
                ScanResult = GetXmlValues.get(finalxml, "ScanResult");
                switchScancode_waitmsgEventMsg(EventKey, ScanType, ScanResult);
            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.pic_sysphoto)) {// ϵͳշͼ¼

            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.pic_photo_or_album)) {// ջᷢͼ¼

            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.pic_weixin)) {// ջᷢͼ¼

            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.location_select)) {// λѡ¼

            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.batch_job_result)) {// 첽¼

            } else if (eventtype
                    .equalsIgnoreCase(Parameter.EventType.enter_agent)) {// ԱӦõ¼)
                EventKey = GetXmlValues.get(finalxml, "EventKey");
                switchEnter_agentEventMsg(EventKey);
            }

        }
    }

    /**
     * Ϣ
     *
     * @param Content 
     */
    private void switchTextMsg(String Content) {
        returnXML = getAppClass().switchTextMsg(Content, FromUserName,
                ToUserName);
    }

    /**
     * ¼Ϣ
     *
     * @param EventKey ¼ֵ
     * @throws ClassNotFoundException
     * @throws IllegalAccessException
     * @throws InstantiationException
     */
    private void switchClickEventMsg(String EventKey) {
        returnXML = getAppClass().switchClickEventMsg(EventKey, FromUserName,
                ToUserName);
    }

    /**
     * ˵תӵ¼
     *
     * @param EventKey
     */
    private void switchViewEventMsg(String EventKey) {
        returnXML = getAppClass().switchViewEventMsg(EventKey, FromUserName,
                ToUserName);
    }

    /**
     * ԱӦõ¼
     *
     * @param EventKey
     */
    private void switchEnter_agentEventMsg(String EventKey) {
        returnXML = getAppClass().switchEnter_agentEventMsg(EventKey,
                FromUserName, ToUserName);

    }

    /**
     * ɨ¼¼
     *
     * @param EventKey
     */
    private void switchScancode_pushEventMsg(String EventKey, String ScanType,
                                             String ScanResult) {

        returnXML = getAppClass().switchScancode_pushEventMsg(EventKey,
                ScanType, ScanResult, FromUserName, ToUserName);
    }

    /**
     * ɨ¼ҵϢСʾ¼
     *
     * @param EventKey
     */
    private void switchScancode_waitmsgEventMsg(String EventKey,
                                                String ScanType, String ScanResult) {
        returnXML = getAppClass().switchScancode_waitmsgEventMsg(EventKey,
                ScanType, ScanResult, FromUserName, ToUserName);
    }

    /**
     * עȡע
     */
    private void switchSubscribeEventMsg() {
        returnXML = getAppClass().switchSubscribeEventMsg(AgentID,
                FromUserName, ToUserName);
    }

    /**
     * λ
     *
     * @param Latitude
     * @param Longitude
     * @param Precision
     */
    private void switchLocationEventMsg(String Latitude, String Longitude,
                                        String Precision) {
        returnXML = getAppClass().switchLocationEventMsg(AgentID, Latitude,
                Longitude, Precision, FromUserName, ToUserName);
    }

    /**
     * ͼƬϢ
     *
     * @param AgentID ӦID
     */
    private void switchImageMsg(String AgentID, String PicUrl, String MediaId) {
        returnXML = getAppClass().switchImageMsg(PicUrl, MediaId, FromUserName,
                ToUserName);
    }

    /**
     * ƵϢ
     *
     * @param AgentID ӦID
     * @param MediaId ýļidԵûȡýļӿȡ
     * @param Format  ʽamrspeex
     */
    private void switchVoiceMsg(String AgentID, String MediaId, String Format) {
        returnXML = getAppClass().switchVoiceMsg(MediaId, Format, FromUserName,
                ToUserName);
    }

    /**
     * ƵϢ
     *
     * @param AgentID ӦID
     */
    private void switchVideoMsg(String AgentID, String MediaId,
                                String ThumbMediaId) {
        returnXML = getAppClass().switchVideoMsg(MediaId, ThumbMediaId,
                FromUserName, ToUserName);
    }

    /**
     * ƵϢ
     *
     * @param AgentID ӦID
     */
    private void switchShortvideoMsg(String AgentID, String MediaId,
                                     String ThumbMediaId) {
        returnXML = getAppClass().switchShortvideoMsg(MediaId, ThumbMediaId,
                FromUserName, ToUserName);
    }

    /**
     * λϢ
     *
     * @param AgentID ӦID
     */
    private void switchLocationMsg(String AgentID, String Location_X,
                                   String Location_Y, String Scale, String Label) {
        returnXML = getAppClass().switchLocationMsg(Location_X, Location_Y,
                Scale, Label, FromUserName, ToUserName);
    }

    private String getMsgType() {
        return GetXmlValues.get(finalxml, "MsgType");
    }

    private String getEventType() {
        return GetXmlValues.get(finalxml, "Event");
    }

    public String getReturnXML() {
        return returnXML;
    }

    private AppRemote getAppClass() {
        AppRemote appRemote = null;

        String classname = "";
        if (Parameter.appid_DRP.equals(AgentID)) {
            classname = "DRP";
        }

        try {
            Class<?> clazz;
            clazz = Class.forName("com.cnd3b.utility.qywechat.agentclient." + classname.toLowerCase() + "."
                    + classname);
            appRemote = (AppRemote) clazz.newInstance();
        } catch (Exception e) {
            e.printStackTrace();
        }
        return appRemote;
    }
}
