package com.cnd3b.utility;

import com.alibaba.fastjson.JSONException;
import p2.ws.restful.WSRESTService;

import java.lang.management.*;
import java.lang.reflect.InvocationTargetException;
import java.lang.reflect.Method;
import java.text.SimpleDateFormat;
import java.util.Arrays;
import java.util.Calendar;
import java.util.List;

public class sysmsg implements WSRESTService {
    public static final long MB = 1024 * 1024;

    public String getCustMsg() throws JSONException {
        StringBuffer msg = new StringBuffer();
        String cline = "<br/>";
        String kg = "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;";
        {
            msg.append("<!DOCTYPE html>");
            msg.append("<html>");
            msg.append("<head>");
            msg.append("<meta http-equiv=\"Content-Type\" content=\"text/html;charset=utf-8\">");
            msg.append("</head>");
            msg.append("<body>");
            // ӡϵͳϢ
            msg.append("===========ӡϵͳϢ==========").append(cline);
            OperatingSystemMXBean system = ManagementFactory.getOperatingSystemMXBean();
            msg.append("ϵͳ:").append(system.getName()).append(cline);
            msg.append("ϵͳ汾:").append(system.getVersion()).append(cline);
            msg.append("ϵͳļܹ:").append(system.getArch()).append(cline);
            msg.append("õں:").append(system.getAvailableProcessors()).append(cline);
            if (isSunOsMBean(system)) {
                long totalPhysicalMemory = getLongFromOperatingSystem(system, "getTotalPhysicalMemorySize");
                long freePhysicalMemory = getLongFromOperatingSystem(system, "getFreePhysicalMemorySize");
                long usedPhysicalMemorySize = totalPhysicalMemory - freePhysicalMemory;
                msg.append("ڴ(M):").append(totalPhysicalMemory / MB).append(cline);
                msg.append("ڴ(M):").append(usedPhysicalMemorySize / MB).append(cline);

                long totalSwapSpaceSize = getLongFromOperatingSystem(system, "getTotalSwapSpaceSize");
                long freeSwapSpaceSize = getLongFromOperatingSystem(system, "getFreeSwapSpaceSize");
                long usedSwapSpaceSize = totalSwapSpaceSize - freeSwapSpaceSize;
                msg.append("ܽռ(M):").append(totalSwapSpaceSize / MB).append(cline);
                msg.append("ýռ(M):").append(usedSwapSpaceSize / MB).append(cline);
                msg.append("ʣཻռ(M):").append(freeSwapSpaceSize / MB).append(cline);
            }
        }
        {
            // ӡϢ
            msg.append("===========ӡϢ==========").append(cline);
            CompilationMXBean compilation = ManagementFactory.getCompilationMXBean();
            msg.append("JITƣ").append(compilation.getName()).append(cline);
            // жjvmǷֱ֧ʱļ
            if (compilation.isCompilationTimeMonitoringSupported()) {
                msg.append("ܱʱ䣺").append(compilation.getTotalCompilationTime() / 1000).append("").append(cline);
            }
        }
        {
            // ӡϢ
            msg.append("===========ӡϢ==========").append(cline);
            ClassLoadingMXBean classLoad = ManagementFactory.getClassLoadingMXBean();
            msg.append("Ѽ").append(classLoad.getTotalLoadedClassCount()).append(cline);
            msg.append("Ѽصǰࣺ").append(classLoad.getLoadedClassCount()).append(cline);
            msg.append("ж").append(classLoad.getUnloadedClassCount()).append(cline);
        }
        {
            // ӡʱϢ
            msg.append("===========ӡʱϢ==========").append(cline);
            RuntimeMXBean runtime = ManagementFactory.getRuntimeMXBean();
            msg.append("PID=").append(runtime.getName().split("@")[0]).append(cline);
            msg.append("jvm淶:").append(runtime.getSpecName()).append(cline);
            msg.append("jvm淶Ӫ:").append(runtime.getSpecVendor()).append(cline);
            msg.append("jvm淶汾:").append(runtime.getSpecVersion()).append(cline);
            // ںڵĿʼʱ䡣÷ʱĽʱ
            Calendar c = Calendar.getInstance();
            c.setTimeInMillis(runtime.getStartTime());
            msg.append("jvmʱ:").append(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(c.getTime())).append(cline);
            // msg.append("ȡSystem.properties:" + runtime.getSystemProperties()
            // + cline);
            long runtitme = runtime.getUptime();
            String timestr = "";
            long daytimes = 86400000;
            if (runtitme / daytimes > 0) {
                timestr = runtitme / daytimes + "";
                runtitme = runtitme % daytimes;
            }
            long hourtimes = 3600000;
            if (runtitme / hourtimes > 0) {
                timestr = timestr + runtitme / hourtimes + "Сʱ";
                runtitme = runtitme % hourtimes;
            }
            long mtimes = 60000;
            if (runtitme / mtimes > 0) {
                timestr = timestr + runtitme / mtimes + "";
                runtitme = runtitme % mtimes;
            }
            long mmtimes = 1000;
            if (runtitme / mmtimes > 0) {
                timestr = timestr + runtitme / mmtimes + "";
            }
            msg.append("jvmʱ:").append(timestr).append(cline);
            msg.append("jvm:").append(runtime.getVmName()).append(cline);
            msg.append("jvmӪ:").append(runtime.getVmVendor()).append(cline);
            msg.append("jvmʵְ汾:").append(runtime.getVmVersion()).append(cline);
            List<String> args = runtime.getInputArguments();
            if (args != null && !args.isEmpty()) {
                msg.append("vm:").append(cline);
                for (String arg : args) {
                    msg.append(kg).append(arg).append(cline);
                }
            }
            // msg.append("·:" + runtime.getClassPath() + cline);
            // msg.append("·:" + runtime.getBootClassPath() + cline);
            // msg.append("·:" + runtime.getLibraryPath() + cline);
        }
        {
            // ӡڴϢ
            msg.append("===========ӡڴϢ==========").append(cline);
            List<MemoryManagerMXBean> managers = ManagementFactory.getMemoryManagerMXBeans();
            if (managers != null && !managers.isEmpty()) {
                for (MemoryManagerMXBean manager : managers) {
                    msg.append("vmڴ").append(cline).append(kg).append("=").append(manager.getName()).append(cline).append(kg).append(",ڴ=").append(Arrays.deepToString(manager.getMemoryPoolNames())).append(cline).append(kg).append(",ObjectName=").append(manager.getObjectName()).append(cline);
                }
            }
        }
        {
            // ӡϢ
            msg.append("===========ӡϢ==========").append(cline);
            List<GarbageCollectorMXBean> garbages = ManagementFactory.getGarbageCollectorMXBeans();
            for (GarbageCollectorMXBean garbage : garbages) {
                msg.append("ռ").append(cline).append(kg).append("=").append(garbage.getName()).append(cline).append(kg).append("ռ=").append(garbage.getCollectionCount()).append(cline).append(kg).append("ܻʱ=").append(garbage.getCollectionTime()).append(cline).append(kg).append("ڴ=").append(Arrays.deepToString(garbage.getMemoryPoolNames())).append(cline);
            }
        }
        {
            // ӡvmڴ
            msg.append("===========ӡvmڴϢ==========").append(cline);
            MemoryMXBean memory = ManagementFactory.getMemoryMXBean();
            MemoryUsage headMemory = memory.getHeapMemoryUsage();
            msg.append("head:").append(cline);
            msg.append(kg).append("ʼ(M):").append(headMemory.getInit() / MB).append(cline);
            msg.append(kg).append("()(M):").append(headMemory.getMax() / MB).append(cline);
            msg.append(kg).append("ǰ(ʹ)(M):").append(headMemory.getUsed() / MB).append(cline);
            msg.append(kg).append("ύڴ()(M):").append(headMemory.getCommitted() / MB).append(cline);
            msg.append(kg).append("ʹ:").append(Math.round(headMemory.getUsed() * 100 / (double) headMemory.getCommitted(), 2)).append("%").append(cline);

            msg.append("non-headǶ:").append(cline);
            MemoryUsage nonheadMemory = memory.getNonHeapMemoryUsage();
            msg.append(kg).append("ʼ(M):").append(nonheadMemory.getInit() / MB).append(cline);
            msg.append(kg).append("()(M):").append(nonheadMemory.getMax() / MB).append(cline);
            msg.append(kg).append("ǰ(ʹ)(M):").append(nonheadMemory.getUsed() / MB).append(cline);
            msg.append(kg).append("ύڴ()(M):").append(nonheadMemory.getCommitted() / MB).append(cline);
            msg.append(kg).append("ʹ:").append(Math.round(nonheadMemory.getUsed() * 100 / (double) nonheadMemory.getCommitted(), 2)).append("%").append(cline);
        }
        {
            // ӡvmڴϢ
            msg.append("===========ӡvmڴϢ==========").append(cline);

            List<MemoryPoolMXBean> pools = ManagementFactory.getMemoryPoolMXBeans();
            if (pools != null && !pools.isEmpty()) {
                for (MemoryPoolMXBean pool : pools) {
                    // ֻӡһЩڴеԣһЩԣɿĵٶ
                    // ֵʼֵûжĻ-1ʹʱҪע
                    msg.append("vmڴ:").append(cline).append(kg).append("=").append(pool.getName()).append(cline).append(kg).append("ڴ=").append(Arrays.deepToString(pool.getMemoryManagerNames())).append(cline).append(kg).append("ObjectName=").append(pool.getObjectName()).append(cline).append(kg).append("ʼС(M)=").append(pool.getUsage().getInit() / MB).append(cline).append(kg).append("()(M)=").append(pool.getUsage().getMax() / MB).append(cline).append(kg).append("ôС(M)=").append(pool.getUsage().getUsed() / MB).append(cline).append(kg).append("ύ()(M)=").append(pool.getUsage().getCommitted() / MB).append(cline).append(kg).append("ʹ=").append(Math.round((pool.getUsage().getUsed() * 100 / (double) pool.getUsage().getCommitted()), 2)).append("%").append(cline);
                }
            }
        }
        {
            // ӡ߳Ϣ
            msg.append("===========ӡ߳==========").append(cline);

            ThreadMXBean thread = ManagementFactory.getThreadMXBean();
            msg.append("ObjectName=").append(thread.getObjectName()).append(cline);
            msg.append("Ի߳=").append(thread.getThreadCount()).append(cline);
            msg.append("ֵ=").append(thread.getPeakThreadCount()).append(cline);
            msg.append("ִ߳й߳=").append(thread.getTotalStartedThreadCount()).append(cline);
            msg.append("Իػ̣߳daemonThread=").append(thread.getDaemonThreadCount()).append(cline);

            // Ƿ̴߳
            long[] deadlockedIds = thread.findDeadlockedThreads();
            if (deadlockedIds != null && deadlockedIds.length > 0) {
                ThreadInfo[] deadlockInfos = thread.getThreadInfo(deadlockedIds);
                msg.append("߳Ϣ:").append(cline);
                msg.append("\t\t߳\t\t״̬\t\t").append(cline);
                for (ThreadInfo deadlockInfo : deadlockInfos) {
                    msg.append("\t\t").append(deadlockInfo.getThreadName()).append("\t\t").append(deadlockInfo.getThreadState()).append("\t\t").append(deadlockInfo.getBlockedTime()).append("\t\t").append(deadlockInfo.getWaitedTime()).append("\t\t").append(deadlockInfo.getStackTrace().toString()).append(cline);
                }
            }
			/*long[] threadIds = thread.getAllThreadIds();
			if (threadIds != null && threadIds.length > 0) {
				ThreadInfo[] threadInfos = thread.getThreadInfo(threadIds);
				msg.append("߳Ϣ:" + cline);
				msg.append("<table border=\"1\" align=\"left\">");
				msg.append("<tr>");
				msg.append("<th>");
				msg.append("߳");
				msg.append("</th>");
				msg.append("<th>");
				msg.append("״̬");
				msg.append("</th>");
				msg.append("<th>");
				msg.append("߳id");
				msg.append("</th>");
				msg.append("</tr>");
				for (ThreadInfo threadInfo : threadInfos) {
					msg.append("<tr>");
					msg.append("<td>");
					msg.append(threadInfo.getThreadName());
					msg.append("</td>");
					msg.append("<td>");
					msg.append(threadInfo.getThreadState());
					msg.append("</td>");
					msg.append("<td>");
					msg.append(threadInfo.getThreadId());
					msg.append("</td>");
					msg.append("</tr>");
				}
				msg.append("</table>");
			}
			*/
        }
        msg.append("</body>");
        msg.append("</html>");
        return msg.toString();
    }

    private static long getLongFromOperatingSystem(OperatingSystemMXBean operatingSystem, String methodName) {
        try {
            final Method method = operatingSystem.getClass().getMethod(methodName, (Class<?>[]) null);
            method.setAccessible(true);
            return (Long) method.invoke(operatingSystem, (Object[]) null);
        } catch (final InvocationTargetException e) {
            if (e.getCause() instanceof Error) {
                throw (Error) e.getCause();
            } else if (e.getCause() instanceof RuntimeException) {
                throw (RuntimeException) e.getCause();
            }
            throw new IllegalStateException(e.getCause());
        } catch (final NoSuchMethodException e) {
            throw new IllegalArgumentException(e);
        } catch (final IllegalAccessException e) {
            throw new IllegalStateException(e);
        }
    }

    private static boolean isSunOsMBean(OperatingSystemMXBean operatingSystem) {
        final String className = operatingSystem.getClass().getName();
        return "com.sun.management.OperatingSystem".equals(className)
                || "com.sun.management.UnixOperatingSystem".equals(className);
    }
}
